//	Album List for Winamp
//	Copyright (C) 1999-2001 Safai Ma
//
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version.
//
//	This program is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details.
//
//	You should have received a copy of the GNU General Public License
//	along with this program; if not, write to the Free Software
//	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#include "stdafx.h"
#include "resource.h"
// Define COMPILE_MULTIMON_STUBS to compile the stubs;
// otherwise, you get the declarations.
#define COMPILE_MULTIMON_STUBS		// already defined in CfgSheet.cpp
#include <multimon.h>
#include <winuser.h>
#include <winnls.h>
#include <time.h>
#include <dbt.h>
#include <zmouse.h>
#include <mbstring.h>
#include "winampalbumlist.h"
#include "config.h"
#include "frontend.h"
#include "wa_ipc.h"
#include "alfront.h"
#include "gen.h"

#include <locale.h>
#include <stdlib.h>
#include <sys/stat.h>

#define WINAMP_AL_CLASS	"Winamp AL"
#define SCAN_PERCENTAGE	5		// 5 percent

const long magicDWord = 0x49474541;

BOOL WINAPI GdiAlphaBlend(HDC, int, int, int, int, HDC, int, int, int, int, BLENDFUNCTION);
extern winampGeneralPurposePlugin plugin;
extern HMODULE hMod;

int CWinampUI::m_nCurrentSelection	= -1;
int CWinampUI::m_nTextHeight		= 13;

SIZE TITLEBAR_LEFT_CORNER = { 25, 20 };		//   0,  0
SIZE TITLEBAR_TITLE = { 72, 20 };			//  26,  0
SIZE TITLEBAR_TITLE_PL = { 100, 20 };		//  26,  0
SIZE TITLEBAR_REPEAT = { 25, 20 };			// 127,  0
SIZE TITLEBAR_RIGHT_CORNER = { 25, 20 };	// 153,  0
SIZE BOTTOM_REPEAT = { 25, 38 };			// 179,  0
SIZE LEFT_REPEAT = { 25, 29 };				//   0, 42
SIZE RIGHT_REPEAT = { 25, 29 };				//  26, 42
SIZE BOTTOM_LEFT = { 125, 38 };				//   0, 72
SIZE BOTTOM_RIGHT = { 150, 38 };			// 126, 72
SIZE CLICKED_CLOSE = { 9, 9 };				//  52, 42
SIZE SLIDER_UP = { 8, 18 };					//  52, 53
SIZE CLICKED_WINSHADE = { 9, 9 };			// 150, 42

SIZE WINSHADE_LEFT = { 25, 14 };			//  72, 42
SIZE WINSHADE_MIDDLE = { 25, 14 };			//  72, 57
SIZE WINSHADE_RIGHT = { 50, 14 };			//  99, 42

RECT rcTextBmp[] =
{
	{   0, 0,   4,  6 }, //  0 - A
	{   5, 0,   9,  6 }, //  1 - B
	{  10, 0,  14,  6 }, //  2 - C
	{  15, 0,  19,  6 }, //  3 - D
	{  20, 0,  24,  6 }, //  4 - E
	{  25, 0,  29,  6 }, //  5 - F
	{  30, 0,  34,  6 }, //  6 - G
	{  35, 0,  39,  6 }, //  7 - H
	{  40, 0,  44,  6 }, //  8 - I
	{  45, 0,  49,  6 }, //  9 - J
	{  50, 0,  54,  6 }, // 10 - K
	{  55, 0,  59,  6 }, // 11 - L
	{  60, 0,  64,  6 }, // 12 - M
	{  65, 0,  69,  6 }, // 13 - N
	{  70, 0,  74,  6 }, // 14 - O
	{  75, 0,  79,  6 }, // 15 - P
	{  80, 0,  84,  6 }, // 16 - Q
	{  85, 0,  89,  6 }, // 17 - R
	{  90, 0,  94,  6 }, // 18 - S
	{  95, 0,  99,  6 }, // 19 - T
	{ 100, 0, 104,  6 }, // 20 - U
	{ 105, 0, 109,  6 }, // 21 - V
	{ 110, 0, 114,  6 }, // 22 - W
	{ 115, 0, 119,  6 }, // 23 - X
	{ 120, 0, 124,  6 }, // 24 - Y
	{ 125, 0, 129,  6 }, // 25 - Z
	{ 130, 0, 134,  6 }, // 26 - "
	{ 135, 0, 139,  6 }, // 27 - @
	{ 140, 0, 144,  6 }, // 28 - |
	{ 145, 0, 149,  6 }, // 29 - 
	{   0, 6,   4, 12 }, // 30 - 0
	{   5, 6,   9, 12 }, // 31 - 1
	{  10, 6,  14, 12 }, // 32 - 2
	{  15, 6,  19, 12 }, // 33 - 3
	{  20, 6,  24, 12 }, // 34 - 4
	{  25, 6,  29, 12 }, // 35 - 5
	{  30, 6,  34, 12 }, // 36 - 6
	{  35, 6,  39, 12 }, // 37 - 7
	{  40, 6,  44, 12 }, // 38 - 8
	{  45, 6,  49, 12 }, // 39 - 9
	{  50, 6,  54, 12 }, // 40 - ...
	{  55, 6,  59, 12 }, // 41 - .
	{  60, 6,  64, 12 }, // 42 - :
	{  65, 6,  69, 12 }, // 43 - (
	{  70, 6,  74, 12 }, // 44 - )
	{  75, 6,  79, 12 }, // 45 - -
	{  80, 6,  84, 12 }, // 46 - '
	{  85, 6,  89, 12 }, // 47 - !
	{  90, 6,  94, 12 }, // 48 - _
	{  95, 6,  99, 12 }, // 49 - +
	{ 100, 6, 104, 12 }, // 50 - backslash
	{ 105, 6, 109, 12 }, // 51 - /
	{ 110, 6, 114, 12 }, // 52 - [
	{ 115, 6, 119, 12 }, // 53 - ]
	{ 120, 6, 124, 12 }, // 54 - ^
	{ 125, 6, 129, 12 }, // 55 - &
	{ 130, 6, 134, 12 }, // 56 - %
	{ 135, 6, 139, 12 }, // 57 - ,
	{ 140, 6, 144, 12 }, // 58 - =
	{ 145, 6, 149, 12 }, // 59 - $
	{ 150, 6, 154, 12 }, // 60 - #
	{   0,12,   4, 18 }, // 61 - 
	{   5,12,   9, 18 }, // 62 - 
	{  10,12,  14, 18 }, // 63 - 
	{  15,12,  19, 18 }, // 64 - ?
	{  20,12,  24, 18 }, // 65 - *
	{ 150, 0, 154,  6 }  // 66 - space
};

HANDLE hTimeThread = NULL;
DWORD dwTimeThreadId = 0;

DWORD WINAPI TimeThreadProc(LPVOID lpParameter)
{
	CWinampAlbumList *pWinampAlbumList = (CWinampAlbumList *)lpParameter;

	HWND hWinamp = FindWindow("Winamp v1.x", NULL);

	int nTimeDifference = 0;
	DWORD dwTickCount = GetTickCount();
	while (pWinampAlbumList->m_hWnd)
	{
		switch (SendMessage(hWinamp, WM_WA_IPC, 0, IPC_ISPLAYING))
		{
		case 0:		// not playing
			if (pWinampAlbumList->m_nCurrentTime != -1)
			{
				pWinampAlbumList->m_nCurrentTime = -1;
				InvalidateRect(pWinampAlbumList->m_hWnd, NULL, FALSE);
			}
			Sleep(1000);
			break;

		case 1:		// playing
			pWinampAlbumList->m_nCurrentTime = SendMessage(hWinamp, WM_WA_IPC, 0, IPC_GETOUTPUTTIME);
			pWinampAlbumList->m_pWinampUI->UpdateTimeDisplay();
			nTimeDifference = 1000 - (pWinampAlbumList->m_nCurrentTime % 1000) + 20;
			Sleep (nTimeDifference);
			break;

		case 3:		// paused
			Sleep(200);
			break;
		}

	}

	return 0;
}

CWinampAlbumList::CWinampAlbumList()
{
	m_hWnd = NULL;
	m_hBmp = NULL;
	m_hBmpText = NULL;
	m_pWinampUI = NULL;
	m_bConnected = FALSE;
	m_hCursorMove = NULL;
	m_hCursorSizeH = NULL;
	m_hCursorClose = NULL;
	m_hCursorArrow = NULL;
	m_hCursorSizeV = NULL;
	m_hCursorResize = NULL;
	m_hCursorStyle = NULL;

	m_hBmpBackground = NULL;
	m_bUsePLBitmap = FALSE;

	m_nCurrentTime = -1;

	m_msgMouseWheel = 0;
	m_bMinimized = FALSE;
}

CWinampAlbumList::~CWinampAlbumList()
{
	WaitForSingleObject(hTimeThread, 500);	// wait for 1/2 second
	CloseHandle(hTimeThread);

	if (m_hWnd) m_hWnd = NULL;
	if (m_hBmp) DeleteObject(m_hBmp);
	if (m_hBmpText) DeleteObject(m_hBmpText);
	if (m_hBmpBackground) DeleteObject(m_hBmpBackground);
	if (m_hCursorMove != NULL)		{ DestroyCursor(m_hCursorMove);   m_hCursorMove   = NULL; }
	if (m_hCursorSizeH != NULL)		{ DestroyCursor(m_hCursorSizeH);  m_hCursorSizeH  = NULL; }
	if (m_hCursorClose != NULL)		{ DestroyCursor(m_hCursorClose);  m_hCursorClose  = NULL; }
	if (m_hCursorArrow != NULL)		{ DestroyCursor(m_hCursorArrow);  m_hCursorArrow  = NULL; }
	if (m_hCursorSizeV != NULL)		{ DestroyCursor(m_hCursorSizeV);  m_hCursorSizeV  = NULL; }
	if (m_hCursorResize != NULL)	{ DestroyCursor(m_hCursorResize); m_hCursorResize = NULL; }
	if (m_hCursorStyle != NULL)		{ DestroyCursor(m_hCursorStyle);  m_hCursorStyle  = NULL; }
	UnregisterClass(WINAMP_AL_CLASS, plugin.hDllInstance);
	m_AlbumList.Shutdown();

	int size = m_LangArray.GetSize();
	for (int i=0; i<size; i++)
	{
		delete (LPLANGINFO)m_LangArray[i];
	}
}

int ConvertHTMLColorToRGB(char *color, int nDef)
{
	if (color == NULL) return nDef;
	if (lstrlen(color) != 7) return nDef;
	if (color[0] != '#') return nDef;
	_mbslwr((unsigned char *)color);

	char mycolor[6] = "\0\0\0\0\0";
	for (int i=0; i<6; i++)
	{
		if (isalpha(color[i+1])) mycolor[i] = color[i+1] - 'a' + 10;
		if (isdigit(color[i+1])) mycolor[i] = color[i+1] - '0';
	}

	int r = mycolor[0] * 16 + mycolor[1];
	int g = mycolor[2] * 16 + mycolor[3];
	int b = mycolor[4] * 16 + mycolor[5];

	return RGB(r, g, b);
}

BOOL CWinampAlbumList::Create(HWND hwndParent)
{
	WNDCLASSEX wndclassex;
	wndclassex.cbSize = sizeof(wndclassex);
	wndclassex.style = CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS;
	wndclassex.lpfnWndProc = DefWindowProc;
	wndclassex.lpszClassName = WINAMP_AL_CLASS;
	wndclassex.cbClsExtra = 0;
	wndclassex.cbWndExtra = 0;
	wndclassex.hInstance = plugin.hDllInstance;
	wndclassex.hIcon = NULL;
	wndclassex.hbrBackground = (HBRUSH)COLOR_WINDOW;
	wndclassex.lpszMenuName = NULL;
	wndclassex.hIconSm = NULL;
	wndclassex.hCursor = NULL;

	RegisterClassEx(&wndclassex);

	// load our accelerator table
	m_hAccTable = LoadAccelerators(plugin.hDllInstance, MAKEINTRESOURCE(IDR_ACCEL_AL));
	m_hAccTableMain = LoadAccelerators(plugin.hDllInstance, MAKEINTRESOURCE(IDR_ACCEL_MAIN));

	// set the plugin's mode
	m_pWinampUI = (al_ws == 0) ? (CWinampUI*)&m_waNormal : (CWinampUI*)&m_waWinshade;

	int width = al_width;
	int height = al_ws ? WINSHADE_HEIGHT : al_height;

	GetTranslations();

	if (al_alphablend != 255)
	{
		HDC hdcDesktop = GetDC(NULL);
		HDC hdcOffscreen = CreateCompatibleDC(hdcDesktop);
		m_hBmpBackground = CreateCompatibleBitmap(hdcDesktop, width, height);
		HBITMAP oldBitmap = (HBITMAP)SelectObject(hdcOffscreen, m_hBmpBackground);
		BitBlt(hdcOffscreen, 0, 0, width, height, hdcDesktop, al_wx, al_wy, SRCCOPY);
		SelectObject(hdcOffscreen, oldBitmap);
		DeleteDC(hdcOffscreen);
		ReleaseDC(NULL, hdcDesktop);
	}

	// center the album list window for the first time
	if ((al_wx == 30000) && (al_wy == 30000))
	{
		al_wx = (GetSystemMetrics(SM_CXSCREEN) - width) / 2;
		al_wy = (GetSystemMetrics(SM_CYSCREEN) - height) / 2;
	}

	// check to make sure our window is onscreen
	RECT rc;
	rc.top = al_wy;
	rc.left = al_wx;
	rc.right = al_wx + width;
	rc.bottom = al_wy + height;
	HMONITOR hCurMonitor = MonitorFromRect(&rc, MONITOR_DEFAULTTONEAREST);
	MONITORINFO mi;
	mi.cbSize = sizeof(MONITORINFO);
	if (GetMonitorInfo(hCurMonitor, &mi))
	{
		if (rc.bottom > mi.rcWork.bottom) al_wy = mi.rcWork.bottom - height;
		else if (rc.top < mi.rcWork.top) al_wy = mi.rcWork.top;

		if (rc.right > mi.rcWork.right) al_wx = mi.rcWork.right - width;
		else if (rc.left < mi.rcWork.left) al_wx = mi.rcWork.left;
	}

	m_hWnd = CreateWindowEx(0, WINAMP_AL_CLASS, "Winamp Album List", WS_POPUP, al_wx, al_wy, width, height, hwndParent, NULL, plugin.hDllInstance, NULL);

	if (m_hWnd == NULL) return FALSE;

	// get rid of the caption
	LONG lStyle = GetWindowLong(m_hWnd, GWL_STYLE);
	SetWindowLong(m_hWnd, GWL_STYLE, lStyle & ~WS_POPUP);

	// turn on "Always on Litestep virtual desktop" mode
	if (keeponscreen & 0x2)
	{
		SetWindowLong(m_hWnd, GWL_USERDATA, magicDWord);
	}

	// get skin
	RefreshSkin();
	m_waNormal.RefreshFont();
	m_waWinshade.RefreshFont();

	SetProp(m_hWnd, "CWinampAlbumList", (HANDLE)this);

	// allow drag & drop
	DragAcceptFiles(m_hWnd, TRUE);

	// register wheel mouse stuff
	UINT uiMsh_MsgMouseWheel, uiMsh_Msg3DSupport, uiMsh_MsgScrollLines;
	BOOL f3DSupport;
	int iScrollLines;
	if (HwndMSWheel(&uiMsh_MsgMouseWheel, &uiMsh_Msg3DSupport, &uiMsh_MsgScrollLines, &f3DSupport, &iScrollLines))
	{
		OutputDebugString("CWinampAlbumList -- has MouseWheel support\n");
	}
	m_msgMouseWheel = uiMsh_MsgMouseWheel;

	if (al_open) ShowWindow(SW_SHOW);
	if (IsIconic(hwndParent)) ShowWindow(SW_HIDE);

	m_AlbumList.Startup(m_hWnd);

	// 1. Read cached albums from file
	// 2. Add new albums
	// 3. Remove old albums that does not exist anymore
	m_AlbumList.ReadAlbumList();
	if (al_startup_scan)
	{
		RefreshAlbums(TRUE/*QuickRefresh*/);
	}

	m_pWinampUI->MakeSelectionVisible();
	
	hTimeThread = CreateThread(NULL, 0, TimeThreadProc, this, CREATE_SUSPENDED, &dwTimeThreadId);
	SetThreadPriority(hTimeThread, THREAD_PRIORITY_BELOW_NORMAL);
	ResumeThread(hTimeThread);

	// setup config pages
	m_TreePS.AddPage(&m_SearchPathPage, "Search Path",	0);
	m_TreePS.AddPage(&m_OptionsPage,	"Options",		0);
	m_TreePS.AddPage(&m_AlbumNamingPage,"Album Naming",	1);
	m_TreePS.AddPage(&m_SkinsPage,		"Skins",		0);
	m_TreePS.AddPage(&m_AboutPage,		"About",		0);
	m_TreePS.AddPage(&m_ReadmePage,		"History",		0);

	// remove the temp javascript
	struct _stat buf;
	char tempfile[MAX_PATH] = "";
	if (GetTempPath(MAX_PATH, tempfile) == 0) lstrcpy(tempfile, ".\\");
	lstrcat(tempfile, "albumlist.js");
	if (_stat(tempfile, &buf) != -1) DeleteFile(tempfile);

	if (al_showcover)
	{
		m_waNormal.ShowAlbumInMiniBrowser(m_AlbumList.GetAlbumIndex(al_index));
	}

	if (al_resume_play)
	{
		SendMessage(plugin.hwndParent, WM_WA_IPC, al_resume_pos, IPC_SETPLAYLISTPOS);

		// resume play only if it was playing before
		if (al_resume_time != -1)
		{
			// IPC_STARTPLAY does not work here, it always plays
			// the first song in the playlist :(
			SendMessage(plugin.hwndParent, WM_COMMAND, WINAMP_BUTTON2, 0);
			SendMessage(plugin.hwndParent, WM_WA_IPC, al_resume_time, IPC_JUMPTOTIME);
		}
	}

	return TRUE;
}

void CWinampAlbumList::Shutdown()
{
	// reset them first
	al_resume_time = -1;
	al_resume_pos = 0;

	if (al_resume_play)
	{
		// save position if we're not stopped
		if (SendMessage(plugin.hwndParent, WM_WA_IPC, 0, IPC_ISPLAYING) != 0)
		{
			al_resume_time = SendMessage(plugin.hwndParent, WM_WA_IPC, 0, IPC_GETOUTPUTTIME);
		}

		al_resume_pos = SendMessage(plugin.hwndParent, WM_WA_IPC, 0, IPC_GETLISTPOS);
	}
}

void CWinampAlbumList::ShowWindow(int nCmdShow)
{
	if (nCmdShow == SW_SHOW)
	{
		if (!al_open) return;
	}
	::ShowWindow(m_hWnd, nCmdShow);
}

void CWinampAlbumList::Config()
{
	if (!m_TreePS.IsWindow())
	{
		m_TreePS.Create(IDD_PROPERTYSHEET, plugin.hwndParent);
	}
	else
	{
		m_TreePS.SetForegroundWindow();
	}
}

void CWinampAlbumList::KeepOnScreen()
{
	// turn on "Always on Litestep virtual desktop" mode
	if (keeponscreen & 0x2)
	{
		SetWindowLong(m_hWnd, GWL_USERDATA, magicDWord);
	}
	else
	{
		SetWindowLong(m_hWnd, GWL_USERDATA, 0);
	}
}

void CWinampAlbumList::OnClose()
{
	m_pWinampUI->Close();
}

void CWinampAlbumList::OnPaint()
{
	PAINTSTRUCT ps;
	HDC hDC = BeginPaint(m_hWnd, &ps);

	DrawInterface(hDC);

	EndPaint(m_hWnd, &ps);
}

void CWinampAlbumList::OnLButtonDown(UINT nFlags, POINT point)
{
	m_pWinampUI->LButtonDown(nFlags, point);
}

void CWinampAlbumList::OnLButtonUp(UINT nFlags, POINT point)
{
	m_pWinampUI->LButtonUp(nFlags, point);
}

void CWinampAlbumList::OnLButtonDblClk(UINT nFlags, POINT point)
{
	m_pWinampUI->LButtonDblClk(nFlags, point);
}

void CWinampAlbumList::OnRButtonUp(UINT nFlags, POINT point)
{
	m_pWinampUI->RButtonUp(nFlags, point);
}

void CWinampAlbumList::OnMouseMove(UINT nFlags, POINT point)
{
	m_pWinampUI->MouseMove(nFlags, point);
}

BOOL CWinampAlbumList::OnEraseBkgnd(HDC hDC)
{
	return 1;
}

void CWinampAlbumList::OnSize(UINT nType, int cx, int cy)
{
	DrawInterface();
}

void CWinampAlbumList::OnShowWindow(BOOL bShow, UINT nStatus)
{
	if (bShow == FALSE && nStatus == SW_PARENTCLOSING)
	{
		RECT rcWnd;
		GetWindowRect(&rcWnd);

		// save position
		al_wx = rcWnd.left;
		al_wy = rcWnd.top;

		// if not in winshade mode, save size
		if (m_pWinampUI == (CWinampUI*)&m_waNormal)
		{
			al_width = rcWnd.right - rcWnd.left;
			al_height = rcWnd.bottom - rcWnd.top;
		}

		m_bMinimized = TRUE;
	}
	else if (bShow == TRUE && nStatus == SW_PARENTOPENING)
	{
		m_bMinimized = FALSE;
	}
}

void CWinampAlbumList::OnDestroy()
{
	if (!m_bMinimized)
	{
		RECT rcWnd;
		GetWindowRect(&rcWnd);

		// save position
		al_wx = rcWnd.left;
		al_wy = rcWnd.top;

		// if not in winshade mode, save size
		if (m_pWinampUI == (CWinampUI*)&m_waNormal)
		{
			al_width = rcWnd.right - rcWnd.left;
			al_height = rcWnd.bottom - rcWnd.top;
		}
	}

	RemoveProp(m_hWnd, "CWinampAlbumList");

	m_hWnd = NULL;
}

void CWinampAlbumList::OnSetFocus(HWND hWnd)
{
	DrawInterface();
}

void CWinampAlbumList::OnKillFocus(HWND hWnd)
{
	DrawInterface();
}

BOOL CWinampAlbumList::OnDeviceChange(UINT nEventType, DWORD dwData)
{
	DEV_BROADCAST_VOLUME *hdr = (DEV_BROADCAST_VOLUME *)dwData;

	switch (nEventType)
	{
	case DBT_DEVICEQUERYREMOVE:
		if (hdr->dbcv_devicetype == DBT_DEVTYP_VOLUME)
		{
			int pos = (int)SendMessage(m_pWinampUI->m_hWinamp, WM_WA_IPC, 0, IPC_GETLISTPOS);
			char *name = (char *)SendMessage(m_pWinampUI->m_hWinamp, WM_WA_IPC, pos, IPC_GETPLAYLISTFILE);

			if (name != NULL)
			{
				
				DWORD unitmask = 1 << (toupper(name[0]) - 'A');

				if (hdr->dbcv_unitmask == unitmask)
				{
					// stop the player
					SendMessage(m_pWinampUI->m_hWinamp, WM_COMMAND, WINAMP_BUTTON4, 0);

				}
			}
			int i=0;
			while (hdr->dbcv_unitmask = (hdr->dbcv_unitmask >> 1)) i++;

			if (al_add_cdroms)
			{
				char path[16];
				wsprintf(path, "%c:", i + 'A');
				m_AlbumList.StopScanning(path);
			}
		}
		return TRUE;

	case DBT_DEVICEREMOVECOMPLETE:
		if (hdr->dbcv_devicetype == DBT_DEVTYP_VOLUME)
		{
			int pos = (int)SendMessage(m_pWinampUI->m_hWinamp, WM_WA_IPC, 0, IPC_GETLISTPOS);
			char *name = (char *)SendMessage(m_pWinampUI->m_hWinamp, WM_WA_IPC, pos, IPC_GETPLAYLISTFILE);

			if (name != NULL)
			{
				
				DWORD unitmask = 1 << (toupper(name[0]) - 'A');

				if (hdr->dbcv_unitmask == unitmask)
				{
					// stop the player
					SendMessage(m_pWinampUI->m_hWinamp, WM_COMMAND, WINAMP_BUTTON4, 0);

				}
			}

			int i=0;
			while (hdr->dbcv_unitmask = (hdr->dbcv_unitmask >> 1)) i++;

			char path[16];
			wsprintf(path, "%c:\\", i + 'A');

			if (al_add_cdroms)
			{
				if (m_pWinampUI->m_nCurrentSelection != -1)
				{
					LPALBUMINFO pInfo = m_AlbumList.GetAlbum(m_pWinampUI->m_nCurrentSelection);
					if ((pInfo == NULL) ||				// album does not exist anymore
						(pInfo->path[0] == (i+'A')))	// album go removed
					{
						m_pWinampUI->m_nCurrentSelection = -1;
					}
				}

				m_AlbumList.StopScanning(path);
				m_AlbumList.RemoveMP3FromList(path);
			}
		}
		return TRUE;

	case DBT_DEVICEARRIVAL:
		// is this a volume change?
		if (hdr->dbcv_devicetype == DBT_DEVTYP_VOLUME)
		{
			//ANDREAS: for some reason the 32nd bit was set on my machine. Should be zero
			hdr->dbcv_unitmask &= 0x7fffff;

			char i=0;
			while (hdr->dbcv_unitmask = (hdr->dbcv_unitmask >> 1)) i++;

			char path[10];
			wsprintf(path, "%c:\\", i + 'A');

			if (al_add_cdroms)
			{
				m_AlbumList.AddMP3ToList(path, TRUE);
			}
		}
		return TRUE;
	}
	return 0;
}

void CWinampAlbumList::OnContextMenu(HWND hWnd, POINT point)
{
	m_pWinampUI->ContextMenu(hWnd, point);
}

void CWinampAlbumList::OnMouseWheel(WORD fwKeys, short zDelta, POINT point)
{
	m_pWinampUI->MouseWheel(fwKeys, zDelta, point);
}

void CWinampAlbumList::OnAccelerator(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	MSG msg;

	msg.hwnd = hwnd;
	msg.message = uMsg;
	msg.wParam = wParam;
	msg.lParam = lParam;
	msg.time = GetMessageTime();
	GetCursorPos(&msg.pt);

	if (!TranslateAccelerator(hwnd, m_hAccTable, &msg))
	{
		TranslateAccelerator(m_pWinampUI->m_hWinamp, m_hAccTableMain, &msg);
	}
}

BOOL CWinampAlbumList::OnCommand(WPARAM wParam, LPARAM lParam)
{
	WORD wNotifyCode = HIWORD(wParam); // notification code 
	WORD wID = LOWORD(wParam);         // item, control, or accelerator identifier 
	HWND hwndCtl = (HWND) lParam;      // handle of control 
 
	switch (wID)
	{
	case IDC_NEXTALBUM:
		m_pWinampUI->NextAlbum();
		return TRUE;

	case IDC_PREVALBUM:
		m_pWinampUI->PrevAlbum();
		return TRUE;

	case IDC_ALBUM_INFO:
		if (m_pWinampUI->m_nCurrentSelection != -1)
		{
			DialogBox(plugin.hDllInstance, MAKEINTRESOURCE(IDD_ALBUMINFO), m_hWnd, AlbumInfoProc);
		}
		return TRUE;

	case IDC_RENAME_ALBUM:
		if (m_pWinampUI->m_nCurrentSelection != -1)
		{
			DialogBox(plugin.hDllInstance, MAKEINTRESOURCE(IDD_RENAMEALBUM), m_hWnd, RenameAlbumProc);
		}
		return TRUE;

	case IDC_WINSHADEMODE:
		m_pWinampUI->WinshadeMode(!al_ws);
		return TRUE;

	case IDC_CLOSE_ALBUMLIST:
		ShowWindow(SW_HIDE);
		al_open = 0;
		return TRUE;

	case IDC_EXPORTLIST:
		m_pWinampUI->ExportList();
		return TRUE;

	case IDC_SELECTALBUM:
		if (al_enqueue) m_pWinampUI->EnqueueAlbum();
		else			m_pWinampUI->SelectAlbum();
		return TRUE;

	case IDC_ENQUEUEALBUM:
		if (al_enqueue) m_pWinampUI->SelectAlbum();
		else			m_pWinampUI->EnqueueAlbum();
		return TRUE;

	case IDC_ENDALBUM:
		m_pWinampUI->EndAlbum();
		return TRUE;

	case IDC_HOMEALBUM:
		m_pWinampUI->HomeAlbum();
		return TRUE;

	case IDC_PAGEUPALBUM:
		m_pWinampUI->PageUpAlbum();
		return TRUE;

	case IDC_PAGEDOWNALBUM:
		m_pWinampUI->PageDownAlbum();
		return TRUE;

	case IDC_PLAYNEXTALBUM:
		m_pWinampUI->PlayNextAlbum();
		return TRUE;

	case IDC_PLAYNEXTARTIST:
		m_pWinampUI->PlayNextArtist();
		return TRUE;

	case IDC_PLAYPREVALBUM:
		m_pWinampUI->PlayPrevAlbum();
		return TRUE;

	case IDC_PLAYPREVARTIST:
		m_pWinampUI->PlayPrevArtist();
		return TRUE;

	case IDC_NEXT_WINDOW:
		m_pWinampUI->NextWindow(PANEL_AL);
		return TRUE;

	case IDC_REFRESH:
		RefreshAlbums();
		return TRUE;

	case IDC_REFRESH_QUICK:
		RefreshAlbums(TRUE/*bQuickRefresh*/);
		return TRUE;

	case IDC_VOLUMEUP:
		return SendMessage(m_pWinampUI->m_hWinamp, WM_COMMAND, WINAMP_VOLUMEUP, 0);

	case IDC_VOLUMEDOWN:
		return SendMessage(m_pWinampUI->m_hWinamp, WM_COMMAND, WINAMP_VOLUMEDOWN, 0);

	case IDC_JUMPTOALBUM:
		DialogBox(plugin.hDllInstance, MAKEINTRESOURCE(IDD_JUMPTOALBUM), m_hWnd, JumpToAlbumProc);
		return TRUE;

	case IDC_WRITE_PLAYLIST:
		m_AlbumList.WritePlaylist(m_hWnd, m_pWinampUI->m_nCurrentSelection);
		DrawInterface();
		return TRUE;

	case IDC_SHOW_PROPERTIES:
		{
			void config();
			config();
		}
		return TRUE;

	case IDC_MOVEUP:
		m_pWinampUI->MoveUp();
		return TRUE;

	case IDC_MOVEDOWN:
		m_pWinampUI->MoveDown();
		return TRUE;

	case IDC_SORT_OFF:
		al_sortalbum = 0;
		return TRUE;

	case IDC_SORT_PATH:
	case IDC_SORT_NAME:
	case IDC_SORT_ARTIST:
	case IDC_SORT_YEAR:
	case IDC_SORT_NUMOFSONGS:
	case IDC_SORT_TOTALTIME:
	case IDC_SORT_SHUFFLE:
		al_sortalbum = wID - IDC_SORT_OFF;
		m_pWinampUI->Sort();
		return TRUE;

	case IDC_TIMEFORMAT0:
	case IDC_TIMEFORMAT1:
	case IDC_TIMEFORMAT2:
		al_timeformat = wID - IDC_TIMEFORMAT0;
		DrawInterface();
		return TRUE;

	case IDC_TIMEFORMAT3:
		al_shownum = !al_shownum;
		DrawInterface();
		return TRUE;

	case IDC_SHOW_YEAR:
		al_showyear = !al_showyear;
		DrawInterface();
		return TRUE;

	case IDC_PLAYBACK_STOPPED:
		if (al_autoadvance)
		{
			// if it is not playing... it is probably a FULL STOP
			if (SendMessage(m_pWinampUI->m_hWinamp, WM_WA_IPC, 0, IPC_ISPLAYING) == 0)
				m_pWinampUI->PlayNextAlbum();
		}
		return TRUE;
	}

	return FALSE;
}

void CWinampAlbumList::OnWindowPosChanging(LPWINDOWPOS lpwp)
{
	// we are moving or resizing!!!
	if (((lpwp->flags & SWP_NOMOVE) == 0) || ((lpwp->flags & SWP_NOSIZE) == 0))
	{
		RECT rc;
		GetWindowRect(&rc);

		int x = lpwp->x;
		int y = lpwp->y;
		int width = lpwp->cx;
		int height = lpwp->cy;

		if ((lpwp->flags & SWP_NOSIZE) == 0)
		{
			x = rc.left;
			y = rc.top;
		}
		if ((lpwp->flags & SWP_NOMOVE) == 0)
		{
			width = rc.right - rc.left;
			height = rc.bottom - rc.top;
		}

		HDC hdcDesktop = GetDC(NULL);
		HDC hdcOffscreen = CreateCompatibleDC(hdcDesktop);
		HBITMAP hBmpBackground = CreateCompatibleBitmap(hdcDesktop, width, height);
		HBITMAP oldBitmap = (HBITMAP)SelectObject(hdcOffscreen, hBmpBackground);
		BitBlt(hdcOffscreen, 0, 0, width, height, hdcDesktop, x, y, SRCCOPY);

		x = 0;
		int x1 = lpwp->x - rc.left;
		y = 0;
		int y1 = lpwp->y - rc.top;
		
		if ((lpwp->flags & SWP_NOSIZE) == 0)
		{
			x = x1 = y = y1 = 0;
		}

		width = rc.right - rc.left;
		height = rc.bottom - rc.top;

		if (rc.left > lpwp->x)
		{
			x = - x1;
			x1 = 0;
		}
		if (rc.top > lpwp->y)
		{
			y = - y1;
			y1 = 0;
		}

		width -= max(x, x1);
		height -= max(y, y1);

		HDC hdcSource = CreateCompatibleDC(hdcDesktop);
		HBITMAP oldBitmapSrc = (HBITMAP)SelectObject(hdcSource, m_hBmpBackground);

		BitBlt(hdcOffscreen, x, y, width, height, hdcSource, x1, y1, SRCCOPY);

		SelectObject(hdcOffscreen, oldBitmap);
		SelectObject(hdcSource, oldBitmapSrc);
		DeleteDC(hdcOffscreen);
		DeleteDC(hdcSource);
		ReleaseDC(NULL, hdcDesktop);

		// update the bitmap
		DeleteObject(m_hBmpBackground);
		m_hBmpBackground = hBmpBackground;

		if ((lpwp->flags & SWP_NOMOVE) == 0)
		{
			Redraw();
		}
	}
}

void CWinampAlbumList::OnDropFiles(HDROP hDropInfo)
{
	// get next search path index
	int nStartIndex = 0;
	char paths[40] = "al_path_0";
	char al_path[MAX_PATH] = "";
	while (GetPrivateProfileString(szAppName, paths, "", al_path, MAX_PATH, szPluginINI))
	{
		wsprintf(paths, "al_path_%ld", ++nStartIndex);
	}

	// get number of dragged files
	int nFiles = DragQueryFile(hDropInfo, 0xFFFFFFFF, NULL, 0);

	// write the dragged directory to the INI file and
	// scan it
	char szFile[MAX_PATH] = "";
	for (int i=0; i<nFiles; i++)
	{
		if (DragQueryFile(hDropInfo, i, szFile, MAX_PATH))
		{
			DWORD attr = GetFileAttributes(szFile);
			if ((attr != 0xFFFFFFFF) && 
				((attr & FILE_ATTRIBUTE_DIRECTORY) == FILE_ATTRIBUTE_DIRECTORY))
			{
				wsprintf(paths, "al_path_%ld", nStartIndex+i);
				WritePrivateProfileString(szAppName, paths, szFile, szPluginINI);

				if (lstrlen(szFile))
				{
					m_AlbumList.AddMP3ToList(szFile);
				}
			}
		}
	}

	DragFinish(hDropInfo);
}

LRESULT CWinampAlbumList::OnFrontEnd(WPARAM wParam, LPARAM lParam)
{
	switch (wParam)
	{
	case IPC_GETVERSION:
		return IPC_GetVersion();

	case IPC_PLAYALBUM:			// play a specific album
		return IPC_PlayAlbum(lParam);
	case IPC_PLAYALBUM1:		// play a specific album
		return IPC_PlayAlbum(lParam-1);

	case IPC_ENQUEUEALBUM:		// enqueue a specific album
		return IPC_EnqueueAlbum(lParam);
	case IPC_ENQUEUEALBUM1:		// enqueue a specific album
		return IPC_EnqueueAlbum(lParam-1);

	case IPC_GETALBUMSIZE:		// get number of albums
		return IPC_GetAlbumSize();

	case IPC_PLAYRANDOMALBUM:	// play a random album
		return IPC_PlayRandomAlbum();
	case IPC_PLAYPREVALBUM:		// play a previous album
		return IPC_PlayPreviousAlbum();
	case IPC_PLAYNEXTALBUM:		// play a next album
		return IPC_PlayNextAlbum();
	case IPC_PLAYALLALBUMS:		// play all albums
		return IPC_PlayAllAlbums();

	case IPC_GETALBUMNAME:		// get album name
		return (LRESULT)IPC_GetAlbumName(lParam);
	case IPC_GETALBUMNAME1:		// get album name
		return (LRESULT)IPC_GetAlbumName(lParam-1);

	case IPC_GETALBUMINDEX:		// get current album index
		return IPC_GetAlbumIndex();
	case IPC_GETALBUMINDEX1:	// get current album index
		return IPC_GetAlbumIndex()+1;

	case IPC_GETALBUMYEAR:		// get album year
		return IPC_GetAlbumYear(lParam);
	case IPC_GETALBUMYEAR1:		// get album year
		return IPC_GetAlbumYear(lParam-1);

	case IPC_GETALBUMTITLE:		// get album title
		return (LRESULT)IPC_GetAlbumTitle(lParam);
	case IPC_GETALBUMTITLE1:	// get album title
		return (LRESULT)IPC_GetAlbumTitle(lParam-1);

	case IPC_GETALBUMARTIST:	// get album artist name
		return (LRESULT)IPC_GetAlbumArtist(lParam);
	case IPC_GETALBUMARTIST1:	// get album artist name
		return (LRESULT)IPC_GetAlbumArtist(lParam-1);
	}

	return FALSE;
}

DWORD CWinampAlbumList::IPC_GetVersion()
{
	int major, minor, build;
	GetVersionInformation(major, minor, build);

	return MAKELONG(MAKEWORD(build, 0), MAKEWORD(minor, major));
}

BOOL CWinampAlbumList::IPC_PlayAlbum(DWORD index)
{
	if (m_AlbumList.GetSize())
	{
		LPALBUMINFO album = m_AlbumList.GetAlbum(index);
		if (album)
		{
			if (m_AlbumList.PlayAlbum(album))
			{
				m_pWinampUI->MakeSelectionVisible();
				DrawInterface();
				return TRUE;
			}
		}
	}
	return FALSE;
}

BOOL CWinampAlbumList::IPC_EnqueueAlbum(DWORD index)
{
	if (m_AlbumList.GetSize())
	{
		LPALBUMINFO album = m_AlbumList.GetAlbum(index);
		if (album)
		{
			if (m_AlbumList.EnqueueAlbum(album))
			{
				m_pWinampUI->MakeSelectionVisible();
				DrawInterface();
				return TRUE;
			}
		}
	}
	return FALSE;
}

DWORD CWinampAlbumList::IPC_GetAlbumSize()
{
	return m_AlbumList.GetSize();
}

BOOL CWinampAlbumList::IPC_PlayRandomAlbum()
{
	srand((unsigned)time(NULL));
	return IPC_PlayAlbum(rand() % IPC_GetAlbumSize());
}

BOOL CWinampAlbumList::IPC_PlayPreviousAlbum()
{
	if (m_pWinampUI == NULL) return FALSE;

	m_pWinampUI->PlayPrevAlbum();
	return TRUE;
}

BOOL CWinampAlbumList::IPC_PlayNextAlbum()
{
	if (m_pWinampUI == NULL) return FALSE;

	m_pWinampUI->PlayNextAlbum();
	return TRUE;
}

BOOL CWinampAlbumList::IPC_PlayAllAlbums()
{
	if (m_pWinampUI == NULL) return FALSE;

	m_pWinampUI->PlayAllAlbums();
	return TRUE;
}

char *CWinampAlbumList::IPC_GetAlbumName(DWORD index)
{
	if (m_AlbumList.GetSize())
	{
		LPALBUMINFO album = m_AlbumList.GetAlbum(index);
		if (album)
		{
			return album->name;
		}
	}
	return NULL;
}

int CWinampAlbumList::IPC_GetAlbumIndex()
{
	int size = m_AlbumList.GetSize();
	for (int i=0; i<size; i++)
	{
		if (lstrcmp(m_AlbumList.GetAlbum(i)->path, al_index) == 0)
			return i;
	}
	return -1;
}

int CWinampAlbumList::IPC_GetAlbumYear(DWORD index)
{
	if (m_AlbumList.GetSize())
	{
		LPALBUMINFO album = m_AlbumList.GetAlbum(index);
		if (album)
		{
			return album->nYear;
		}
	}
	return 0;
}

char *CWinampAlbumList::IPC_GetAlbumTitle(DWORD index)
{
	if (m_AlbumList.GetSize())
	{
		LPALBUMINFO album = m_AlbumList.GetAlbum(index);
		if (album)
		{
			return album->album;
		}
	}
	return NULL;
}

char *CWinampAlbumList::IPC_GetAlbumArtist(DWORD index)
{
	if (m_AlbumList.GetSize())
	{
		LPALBUMINFO album = m_AlbumList.GetAlbum(index);
		if (album)
		{
			return album->artist;
		}
	}
	return NULL;
}


void CWinampAlbumList::OnHScroll(int nScrollCode, short int nPos, HWND hwndScrollBar)
{
	m_pWinampUI->HScroll(nScrollCode, nPos, hwndScrollBar);
}

BOOL CWinampAlbumList::OnEndSession(BOOL fEndSession)
{
	if (fEndSession)
	{
		Shutdown();
		config_write();
		WriteAlbumList();
	}
	return TRUE;
}


LRESULT CALLBACK CWinampAlbumList::DefWindowProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	CWinampAlbumList *pWnd = (CWinampAlbumList*)GetProp(hwnd, "CWinampAlbumList");

	if (pWnd == NULL) return ::DefWindowProc(hwnd, uMsg, wParam, lParam);

	POINT point = { (short)LOWORD(lParam), (short)HIWORD(lParam) };

	switch(uMsg)
	{
	case WM_CLOSE:
		pWnd->OnClose();
		return 0;

	case WM_PAINT:
		pWnd->OnPaint();
		return 0;

	case WM_LBUTTONDOWN:
		pWnd->OnLButtonDown((UINT)wParam, point);
		break;

	case WM_LBUTTONUP:
		pWnd->OnLButtonUp((UINT)wParam, point);
		break;

	case WM_RBUTTONUP:
		pWnd->OnRButtonUp((UINT)wParam, point);
		break;

	case WM_LBUTTONDBLCLK:
		pWnd->OnLButtonDblClk((UINT)wParam, point);
		break;

	case WM_MOUSEMOVE:
		pWnd->OnMouseMove((UINT)wParam, point);
		break;

	case WM_ERASEBKGND:
		return pWnd->OnEraseBkgnd((HDC)wParam);

	case WM_SIZE:
		pWnd->OnSize((UINT)wParam, (short)LOWORD(lParam), (short)HIWORD(lParam));
		break;

	case WM_SHOWWINDOW:
		pWnd->OnShowWindow((BOOL)wParam, (int)lParam);
		break;

	case WM_DESTROY:
		pWnd->OnDestroy();
		break;

	case WM_SETFOCUS:
		pWnd->OnSetFocus((HWND)wParam);
		break;

	case WM_KILLFOCUS:
		pWnd->OnKillFocus((HWND)wParam);
		break;

	case WM_DEVICECHANGE:
		pWnd->OnDeviceChange((UINT)wParam, (DWORD)lParam);
		break;

	case WM_CONTEXTMENU:
		pWnd->OnContextMenu((HWND)wParam, point);
		break;

	case WM_MOUSEWHEEL:
		pWnd->OnMouseWheel((WORD)LOWORD(wParam), (short)HIWORD(wParam), point);
		return TRUE;

	case WM_KEYDOWN:
	case WM_SYSKEYDOWN:
		pWnd->OnAccelerator(hwnd, uMsg, wParam, lParam);
		break;

	case WM_COMMAND:
		return pWnd->OnCommand(wParam, lParam);

		// Alpha Blending stuff
	case WM_WINDOWPOSCHANGING:
		if (al_alphablend != 255) pWnd->OnWindowPosChanging((LPWINDOWPOS)lParam);
		break;

	case WM_DROPFILES:
		pWnd->OnDropFiles((HDROP)wParam);
		return 0;

	case WM_AL_IPC:
		return pWnd->OnFrontEnd(wParam, lParam);

//	case WM_HSCROLL:
//		pWnd->OnHScroll((int)LOWORD(wParam), (short int)HIWORD(wParam), (HWND)lParam);
//		return 0;

	case WM_ENDSESSION:
		return pWnd->OnEndSession((BOOL)wParam);

	case WM_SETCURSOR:
		return 0;
	}

	// wheel mouse
	if (pWnd->m_msgMouseWheel && (pWnd->m_msgMouseWheel == uMsg))
	{
		// Convert from MSH_MOUSEWHEEL to WM_MOUSEWHEEL.
		WORD keyState = 0;
		keyState |= (::GetKeyState(VK_CONTROL) < 0) ? MK_CONTROL : 0;
		keyState |= (::GetKeyState(VK_SHIFT) < 0) ? MK_SHIFT : 0;

		return SendMessage(hwnd, WM_MOUSEWHEEL, (wParam << 16) | keyState, lParam);
	}

	return ::DefWindowProc(hwnd, uMsg, wParam, lParam);
}

void CWinampAlbumList::ChooseCursor(POINT point)
{
	if (usecursors)
	{
		m_pWinampUI->ChooseCursor(point);
	}
	else
	{
		SetCursor(LoadCursor(NULL, IDC_ARROW));
	}
}

void CWinampAlbumList::DrawInterface(HDC hDC/*=NULL*/)
{
	m_pWinampUI->DrawInterface(hDC);
}

void CWinampAlbumList::InitPanel(int nWnd)
{
	RECT rc1, rc2;
	::GetWindowRect(m_hWndDock[nWnd], &rc1);

	m_dwDocked[nWnd] = 0xFFFFFFFF;
	for (int i=0; i<5; i++)
	{
		// skip
		if (nWnd == i) continue;
		if (!::IsWindowVisible(m_hWndDock[i])) continue;

		::GetWindowRect(m_hWndDock[i], &rc2);

		BOOL bHorizontal = FALSE;

		if (rc1.bottom == rc2.top)
		{
			if ((rc2.right >= rc1.left) && (rc2.left <= rc1.right))
			{
				m_dwDocked[nWnd] = SETDOCKBOTTOM(m_dwDocked[nWnd], i);
			}
		}
		else if (rc1.top == rc2.bottom)
		{
			if ((rc2.right >= rc1.left) && (rc2.left <= rc1.right))
			{
				m_dwDocked[nWnd] = SETDOCKTOP(m_dwDocked[nWnd], i);
			}
		}
		else if (rc1.left == rc2.right)
		{
			if ((rc2.bottom > rc1.top) && (rc2.top < rc1.bottom))
			{
				m_dwDocked[nWnd] = SETDOCKLEFT(m_dwDocked[nWnd], i);
				bHorizontal = TRUE;
			}
		}
		else if (rc1.right == rc2.left)
		{
			if ((rc2.bottom > rc1.top) && (rc2.top < rc1.bottom))
			{
				m_dwDocked[nWnd] = SETDOCKRIGHT(m_dwDocked[nWnd], i);
				bHorizontal = TRUE;
			}
		}

		// albumlist
		if (nWnd == PANEL_AL)
		{
			if (bHorizontal)
			{
				m_nDockingOffsetY[i] = rc1.top - rc2.top;
			}
			else
			{
				m_nDockingOffsetX[i] = rc1.left - rc2.left;
			}
		}
	}
}

void CWinampAlbumList::InitDocking(int nPanel)
{
	int i;
	for (i=0; i<5; i++)
	{
		m_dwDocked[i] = 0xFFFFFFFF;
		m_hWndDock[i] = NULL;
		m_bChecking[i] = FALSE;
		m_nDockingOffsetX[i] = 0;
		m_nDockingOffsetY[i] = 0;
	}

	m_hWndDock[PANEL_AL] = m_pWinampUI->m_hWnd;
	m_hWndDock[PANEL_PE] = m_pWinampUI->m_hWinampPE;
	m_hWndDock[PANEL_EQ] = m_pWinampUI->m_hWinampEQ;
	m_hWndDock[PANEL_MB] = m_pWinampUI->m_hWinampMB;
	m_hWndDock[PANEL_MN] = m_pWinampUI->m_hWinamp;

	for (i=0; i<5; i++)
	{
		InitPanel(i);
		
#ifdef _DEBUG
		char deb[256];
		wsprintf(deb, "DOCKING(%ld) -- 0x%08x\n", i, m_dwDocked[i]);
		OutputDebugString(deb);
#endif
	}

	m_bConnected = IsConnected(PANEL_AL, nPanel);
}

BOOL CWinampAlbumList::IsDocked()
{
	return m_bConnected;
}

BOOL CWinampAlbumList::IsConnected(int nStart, int nEnd)
{
	if (m_bChecking[nStart]) return FALSE;

	m_bChecking[nStart] = TRUE;

	BOOL bConnected = FALSE;

	int right	= GETDOCKRIGHT	(m_dwDocked[nStart]);
	int left	= GETDOCKLEFT	(m_dwDocked[nStart]);
	int bottom	= GETDOCKBOTTOM	(m_dwDocked[nStart]);
	int top		= GETDOCKTOP	(m_dwDocked[nStart]);

	if (right == nEnd)			bConnected = TRUE;
	else if (left == nEnd)		bConnected = TRUE;
	else if (bottom == nEnd)	bConnected = TRUE;
	else if (top == nEnd)		bConnected = TRUE;

	if (right != 0xFF && !bConnected)	bConnected = IsConnected(right, nEnd);
	if (left != 0xFF && !bConnected)	bConnected = IsConnected(left, nEnd);
	if (bottom != 0xFF && !bConnected)	bConnected = IsConnected(bottom, nEnd);
	if (top != 0xFF && !bConnected)		bConnected = IsConnected(top, nEnd);

	m_bChecking[nStart] = FALSE;

	return bConnected;
}

BOOL CWinampAlbumList::IsConnected2(int nStart, int nEnd)
{
	if (nStart == nEnd) return TRUE;
	if (m_bChecking[nStart]) return FALSE;

	m_bChecking[nStart] = TRUE;

	BOOL bConnected = FALSE;

	int right	= GETDOCKRIGHT	(m_dwDocked[nStart]);
	int left	= GETDOCKLEFT	(m_dwDocked[nStart]);
	int bottom	= GETDOCKBOTTOM	(m_dwDocked[nStart]);
	int top		= GETDOCKTOP	(m_dwDocked[nStart]);

	if (right == PANEL_AL)		right = 0xFF;
	if (left == PANEL_AL)		left = 0xFF;
	if (bottom == PANEL_AL)		bottom = 0xFF;
	if (top == PANEL_AL)		top = 0xFF;

	if (right == nEnd)			bConnected = TRUE;
	else if (left == nEnd)		bConnected = TRUE;
	else if (bottom == nEnd)	bConnected = TRUE;
	else if (top == nEnd)		bConnected = TRUE;

	if (right != 0xFF && !bConnected)	bConnected = IsConnected(right, nEnd);
	if (left != 0xFF && !bConnected)	bConnected = IsConnected(left, nEnd);
	if (bottom != 0xFF && !bConnected)	bConnected = IsConnected(bottom, nEnd);
	if (top != 0xFF && !bConnected)		bConnected = IsConnected(top, nEnd);

	m_bChecking[nStart] = FALSE;

	return bConnected;
}

void CWinampAlbumList::MoveDocking(int nPanel)
{
	if (!m_bConnected) return;

	int right	= GETDOCKRIGHT	(m_dwDocked[PANEL_AL]);
	int left	= GETDOCKLEFT	(m_dwDocked[PANEL_AL]);
	int bottom	= GETDOCKBOTTOM	(m_dwDocked[PANEL_AL]);
	int top		= GETDOCKTOP	(m_dwDocked[PANEL_AL]);

	// give priority to the panel that is moving
	if (right == nPanel) left = bottom = top = 0xFF;
	if (left == nPanel) right = bottom = top = 0xFF;
	if (bottom == nPanel) left = right = top = 0xFF;
	if (top == nPanel) left = right = bottom = 0xFF;

	BOOL bDone = FALSE;

	if (right != 0xFF && !bDone && IsConnected2(right, PANEL_MN))
	{
		RECT rc1, rc2;
		GetWindowRect(&rc1);
		::GetWindowRect(m_hWndDock[right], &rc2);
		SetWindowPos(NULL, rc2.left - (rc1.right - rc1.left), rc2.top + m_nDockingOffsetY[right], 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);

		MoveOtherPanels(rc2.left - rc1.right, rc2.top + m_nDockingOffsetY[right] - rc1.top);

		bDone = TRUE;
	}
	if (left != 0xFF && !bDone && IsConnected2(left, PANEL_MN))
	{
		RECT rc1, rc2;
		GetWindowRect(&rc1);
		::GetWindowRect(m_hWndDock[left], &rc2);
		SetWindowPos(NULL, rc2.right, rc2.top + m_nDockingOffsetY[left], 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);

		MoveOtherPanels(rc2.right - rc1.left, rc2.top + m_nDockingOffsetY[left] - rc1.top);

		bDone = TRUE;
	}
	if (top != 0xFF && !bDone && IsConnected2(top, PANEL_MN))
	{
		RECT rc1, rc2;
		GetWindowRect(&rc1);
		::GetWindowRect(m_hWndDock[top], &rc2);
		SetWindowPos(NULL, rc2.left + m_nDockingOffsetX[top], rc2.bottom, 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);

		MoveOtherPanels(rc2.left + m_nDockingOffsetX[top] - rc1.left, rc2.bottom - rc1.top);

		bDone = TRUE;
	}
	if (bottom != 0xFF && !bDone && IsConnected2(bottom, PANEL_MN))
	{
		RECT rc1, rc2;
		GetWindowRect(&rc1);
		::GetWindowRect(m_hWndDock[bottom], &rc2);
		SetWindowPos(NULL, rc2.left + m_nDockingOffsetX[bottom], rc2.top - (rc1.bottom - rc1.top), 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);

		MoveOtherPanels(rc2.left + m_nDockingOffsetX[bottom] - rc1.left, rc2.top - rc1.bottom);

		bDone = TRUE;
	}
}

void CWinampAlbumList::MoveOtherPanels(int xOffset, int yOffset)
{
	if (IsConnected(PANEL_MN, PANEL_PE) && !IsConnected2(PANEL_MN, PANEL_PE))
	{
		RECT rc1;
		::GetWindowRect(m_pWinampUI->m_hWinampPE, &rc1);

		OffsetRect(&rc1, xOffset, yOffset);

		::SetWindowPos(m_pWinampUI->m_hWinampPE, NULL, rc1.left, rc1.top, 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);
	}
	if (IsConnected(PANEL_MN, PANEL_EQ) && !IsConnected2(PANEL_MN, PANEL_EQ))
	{
		RECT rc1;
		::GetWindowRect(m_pWinampUI->m_hWinampEQ, &rc1);

		OffsetRect(&rc1, xOffset, yOffset);

		::SetWindowPos(m_pWinampUI->m_hWinampEQ, NULL, rc1.left, rc1.top, 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);
	}
	if (IsConnected(PANEL_MN, PANEL_MB) && !IsConnected2(PANEL_MN, PANEL_MB))
	{
		RECT rc1;
		::GetWindowRect(m_pWinampUI->m_hWinampMB, &rc1);

		OffsetRect(&rc1, xOffset, yOffset);

		::SetWindowPos(m_pWinampUI->m_hWinampMB, NULL, rc1.left, rc1.top, 0, 0, SWP_NOSIZE|SWP_NOACTIVATE|SWP_NOZORDER);
	}
}

void CWinampAlbumList::NextWindow(int nPanel)
{
	m_pWinampUI->NextWindow(nPanel);
}

void CWinampAlbumList::RefreshFont()
{
	m_waNormal.RefreshFont();
	m_waWinshade.RefreshFont();
}

void CWinampAlbumList::RefreshSkin()
{
	// get skin directory
	char skinname_buffer[MAX_PATH] = "";
	SendMessage(plugin.hwndParent, WM_WA_IPC, (WPARAM)skinname_buffer, IPC_GETSKIN);

	// initialize to default skin first
	color_normal		= RGB(0x00,0xff,0x00);
	color_current		= RGB(0xff,0xff,0xff);
	color_normalbg		= RGB(0x00,0x00,0x00);
	color_selectedbg	= RGB(0x00,0x00,0xc6);
	color_cdrom			= RGB(0xc0,0xc0,0xff);

	// get "optional" default font from language pack (T-Matsuo)
	GetPrivateProfileString("Options", "al_list_font", "Arial", color_font, MAX_PATH, szLangINI);

	m_bUsePLBitmap		= FALSE;

	// free any resource if exist
	if (m_hBmp != NULL)				{ DeleteObject(m_hBmp);          m_hBmp          = NULL; }
	if (m_hBmpText != NULL)			{ DeleteObject(m_hBmpText);      m_hBmpText      = NULL; }
	if (m_hCursorMove != NULL)		{ DestroyCursor(m_hCursorMove);   m_hCursorMove   = NULL; }
	if (m_hCursorSizeH != NULL)		{ DestroyCursor(m_hCursorSizeH);  m_hCursorSizeH  = NULL; }
	if (m_hCursorClose != NULL)		{ DestroyCursor(m_hCursorClose);  m_hCursorClose  = NULL; }
	if (m_hCursorArrow != NULL)		{ DestroyCursor(m_hCursorArrow);  m_hCursorArrow  = NULL; }
	if (m_hCursorSizeV != NULL)		{ DestroyCursor(m_hCursorSizeV);  m_hCursorSizeV  = NULL; }
	if (m_hCursorResize != NULL)	{ DestroyCursor(m_hCursorResize); m_hCursorResize = NULL; }
	if (m_hCursorStyle != NULL)		{ DestroyCursor(m_hCursorStyle);  m_hCursorStyle  = NULL; }

	SetWindowRgn(m_hWnd, NULL, TRUE);

	// try to load skin
	if (lstrlen(skinname_buffer))
	{
		char filename_bmp[MAX_PATH];
		int len = lstrlen(skinname_buffer);
		lstrcpy(filename_bmp, skinname_buffer);
		lstrcpy(filename_bmp + len, "\\albumlist.bmp");
		m_hBmp = (HBITMAP)LoadImage(NULL, filename_bmp, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

		// playlist editor's skin
		if ((m_hBmp == NULL) && al_useplskin)
		{
			lstrcpy(filename_bmp + len, "\\pledit.bmp");
			m_hBmp = (HBITMAP)LoadImage(NULL, filename_bmp, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

			if (m_hBmp) m_bUsePLBitmap = TRUE;
		}

		// make sure our panel is skin'ed first
		if (m_hBmp)
		{
			lstrcpy(filename_bmp + len, "\\text.bmp");
			m_hBmpText = (HBITMAP)LoadImage(NULL, filename_bmp, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);

			char filename_cur[MAX_PATH];
			lstrcpy(filename_cur, skinname_buffer);
			lstrcpy(filename_cur + len, "\\ptbar.cur");
			m_hCursorMove	= (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
			lstrcpy(filename_cur + len, "\\psize.cur");
			m_hCursorSizeH	= (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
			lstrcpy(filename_cur + len, "\\pclose.cur");
			m_hCursorClose	= (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
			lstrcpy(filename_cur + len, "\\pnormal.cur");
			m_hCursorArrow	= (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
			lstrcpy(filename_cur + len, "\\pvscroll.cur");
			m_hCursorSizeV	= (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
			lstrcpy(filename_cur + len, "\\psize.cur");
			m_hCursorResize = (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
			lstrcpy(filename_cur + len, "\\pwinbut.cur");
			m_hCursorStyle = (HICON)LoadImage(NULL, filename_cur, IMAGE_CURSOR, 0, 0, LR_LOADFROMFILE);
		}

		char filename_color[MAX_PATH];
		lstrcpy(filename_color, skinname_buffer);
		lstrcpy(filename_color + len, "\\albumlist.txt");

		// use playlist skin?
		if (m_bUsePLBitmap)
		{
			lstrcpy(filename_color + len, "\\pledit.txt");
		}

		char color_temp[16];
		GetPrivateProfileString("Text", "Normal", "", color_temp, 16, filename_color);
		color_normal = ConvertHTMLColorToRGB(color_temp, color_normal);
		GetPrivateProfileString("Text", "Current", "", color_temp, 16, filename_color);
		color_current = ConvertHTMLColorToRGB(color_temp, color_current);
		GetPrivateProfileString("Text", "NormalBG", "", color_temp, 16, filename_color);
		color_normalbg = ConvertHTMLColorToRGB(color_temp, color_normalbg);
		GetPrivateProfileString("Text", "SelectedBG", "", color_temp, 16, filename_color);
		color_selectedbg = ConvertHTMLColorToRGB(color_temp, color_selectedbg);
		GetPrivateProfileString("Text", "Font", color_font, color_font, MAX_PATH, filename_color);

		if (GetPrivateProfileString("Text", "CDROM", "", color_temp, 16, filename_color))
		{
			color_cdrom = ConvertHTMLColorToRGB(color_temp, color_cdrom);
		}
		else	// try to create a color for it then
		{
#if 0
			WORD r = GetRValue(color_normal);
			WORD g = GetGValue(color_normal);
			WORD b = GetBValue(color_normal);

			r *= (r & 0x80) ? 85 : 115;		r /= 100;
			g *= (g & 0x80) ? 85 : 115;		g /= 100;
			b *= (b & 0x80) ? 85 : 115;		b /= 100;

			color_cdrom = RGB(r,g,b);
#else
			color_cdrom = color_normal;
#endif
		}
	}

	// if failed to load external skin, try internal
	HINSTANCE hModule = GetModuleHandle(NULL);
	if (m_hBmp == NULL)				m_hBmp			= (HBITMAP)LoadImage(plugin.hDllInstance, MAKEINTRESOURCE(IDB_ALBUMLIST), IMAGE_BITMAP, 0,0, LR_CREATEDIBSECTION);
	if (m_hBmpText == NULL)			m_hBmpText		= (HBITMAP)LoadImage(hModule, MAKEINTRESOURCE(134), IMAGE_BITMAP, 0,0, LR_CREATEDIBSECTION);
	if (m_hCursorMove == NULL)		m_hCursorMove	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_MOVE));
	if (m_hCursorSizeH == NULL)		m_hCursorSizeH	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_SIZE_H));
	if (m_hCursorClose == NULL)		m_hCursorClose	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_CLOSE));
	if (m_hCursorArrow == NULL)		m_hCursorArrow	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_ARROW));
	if (m_hCursorSizeV == NULL)		m_hCursorSizeV	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_SIZE_V));
	if (m_hCursorResize == NULL)	m_hCursorResize	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_RESIZE));
	if (m_hCursorStyle == NULL)		m_hCursorStyle	= LoadCursor(hModule, MAKEINTRESOURCE(WINAMP_CURSOR_ARROW));

	// initialize both modes with the hwnd and bitmap handle
	m_waNormal.Init(this, m_hWnd, m_hBmp, m_hBmpText);
	m_waNormal.InitCursors(m_hCursorMove, m_hCursorSizeH, m_hCursorClose, m_hCursorArrow, m_hCursorSizeV, m_hCursorResize, m_hCursorStyle);
	m_waWinshade.Init(this, m_hWnd, m_hBmp, m_hBmpText);
	m_waWinshade.InitCursors(m_hCursorMove, m_hCursorSizeH, m_hCursorClose, m_hCursorArrow, m_hCursorSizeV, m_hCursorResize, m_hCursorStyle);

	m_waNormal.RefreshFont();
	m_waWinshade.RefreshFont();

	DrawInterface();
}

void CWinampAlbumList::RefreshAlbums(BOOL bQuick /*=FALSE*/)
{
	// reset variable
	m_pWinampUI->Refresh();

	// remove all albums
	if (!bQuick)
	{
		m_AlbumList.Shutdown();
		m_AlbumList.Startup(m_hWnd);
	}
	else
	{
		m_AlbumList.RemoveMP3NotInSearchPath();
		m_AlbumList.RemoveOMP3FromList();
	}

	int i=0;
	char paths[40] = "al_path";
	char al_path[MAX_PATH] = "";
	while (1)
	{
		DWORD dwRet = GetPrivateProfileString(szAppName, paths, "", al_path, MAX_PATH, szPluginINI);

		if (dwRet == 0 && i != 0)	break;

		if (lstrlen(al_path))
		{
			m_AlbumList.AddMP3ToList(al_path);
		}
		wsprintf(paths, "al_path_%ld", i++);
	}
	
	if (al_add_cdroms)
	{
		m_AlbumList.AddMP3CDsToList();
	}
}

void CWinampAlbumList::GetTranslations()
{
	char alpath[MAX_PATH] = "";
	wsprintf(alpath, "%s\\*.al", szLangDir);

	HANDLE hFile;
	WIN32_FIND_DATA FindFileData;
	if ((hFile = FindFirstFile(alpath, &FindFileData)) != INVALID_HANDLE_VALUE)
	{
		char lang_ini[MAX_PATH] = "";
		wsprintf(lang_ini, "%s\\%s", szLangDir, FindFileData.cFileName);

		char lang[MAX_PATH] = "";
		GetPrivateProfileString("Info", "Language", "", lang, MAX_PATH, lang_ini);
		if (lang[0] != 0)
		{
			LPLANGINFO pLangInfo = new LANGINFO;
			lstrcpy(pLangInfo->filename, FindFileData.cFileName);
			lstrcpy(pLangInfo->pathname, lang_ini);
			lstrcpy(pLangInfo->language, lang);

			m_LangArray.Add(pLangInfo);
		}

		while (FindNextFile(hFile, &FindFileData) != 0)
		{
			char lang_ini[MAX_PATH] = "";
			wsprintf(lang_ini, "%s\\%s", szLangDir, FindFileData.cFileName);
			GetPrivateProfileString("Info", "Language", "", lang, MAX_PATH, lang_ini);
			if (lang[0] != 0)
			{
				LPLANGINFO pLangInfo = new LANGINFO;
				lstrcpy(pLangInfo->filename, FindFileData.cFileName);
				lstrcpy(pLangInfo->pathname, lang_ini);
				lstrcpy(pLangInfo->language, lang);

				m_LangArray.Add(pLangInfo);
			}
		}
		FindClose(hFile);
	}
}

///////////////////////////////////////////

void CWinampUI::Init(CWinampAlbumList *pWinampAL, HWND hWnd, HBITMAP hBitmap, HBITMAP hBitmapText)
{
	m_pWinampAL = pWinampAL;
	m_pAlbumList = &(pWinampAL->m_AlbumList);
	m_hWnd = hWnd;
	m_hBmp = hBitmap;
	m_hBmpText = hBitmapText;

	m_hWinamp = ALFindWindow("Winamp v1.x", NULL);
	m_hWinampPE = ALFindWindow("Winamp PE", NULL);
	m_hWinampMB = ALFindWindow("Winamp MB", NULL);
	m_hWinampEQ = ALFindWindow("Winamp EQ", NULL);
}

void CWinampUI::InitCursors(HCURSOR hMove, HCURSOR	hSizeH, HCURSOR	hClose, HCURSOR	hArrow, HCURSOR	hSizeV, HCURSOR	hResize, HCURSOR hStyle)
{
	m_hCursorMove	= hMove;
	m_hCursorSizeH	= hSizeH;
	m_hCursorClose	= hClose;
	m_hCursorArrow	= hArrow;
	m_hCursorSizeV	= hSizeV;
	m_hCursorResize	= hResize;
	m_hCursorStyle	= hStyle;
}

void CWinampUI::ChooseCursor(POINT point)
{
	HCURSOR hCursor = m_hCursorArrow;

	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// dragging rectangle
	if (m_wafDrag.PtInFunction(point, &rcWnd))
	{
		hCursor = m_hCursorMove;
	}

	// close rectangle
	if (m_wafClose.PtInFunction(point, &rcWnd))
	{
		hCursor = m_hCursorClose;
	}

	// winshade rectangle
	if (m_wafWinshade.PtInFunction(point, &rcWnd))
	{
		hCursor = m_hCursorStyle;
	}

	if (m_wafClose.IsClicked())		hCursor = m_hCursorClose;
	if (m_wafDrag.IsClicked())		hCursor = m_hCursorMove;
	if (m_wafWinshade.IsClicked())	hCursor = m_hCursorStyle;

	SetCursor(hCursor);
}

BOOL CWinampUI::SnapDesktop(POINT point, LPRECT lprcWnd)
{
	BOOL bRet = FALSE;

	ClientToScreen(m_hWnd, &point);

	HMONITOR hCurMonitor = MonitorFromPoint(point, MONITOR_DEFAULTTONEAREST);
	MONITORINFO mi;
	mi.cbSize = sizeof(MONITORINFO);

	if (GetMonitorInfo(hCurMonitor, &mi))
	{
		if (-snaplen < (lprcWnd->top - mi.rcWork.top) && (lprcWnd->top - mi.rcWork.top) < snaplen)
		{
			OffsetRect(lprcWnd, 0, mi.rcWork.top - lprcWnd->top);
			bRet = TRUE;
		}
		if (-snaplen < (mi.rcWork.bottom - lprcWnd->bottom) && (mi.rcWork.bottom - lprcWnd->bottom) < snaplen)
		{
			OffsetRect(lprcWnd, 0, mi.rcWork.bottom - lprcWnd->bottom);
			bRet = TRUE;
		}
		if (-snaplen < (lprcWnd->left - mi.rcWork.left) && (lprcWnd->left - mi.rcWork.left) < snaplen)
		{
			OffsetRect(lprcWnd, mi.rcWork.left - lprcWnd->left, 0);
			bRet = TRUE;
		}
		if (-snaplen < (mi.rcWork.right - lprcWnd->right) && (mi.rcWork.right - lprcWnd->right) < snaplen)
		{
			OffsetRect(lprcWnd, mi.rcWork.right - lprcWnd->right, 0);
			bRet = TRUE;
		}
	}

	return bRet;
}

BOOL CWinampUI::SnapWindow(HWND hwndTarget, LPRECT lprcWnd)
{
	RECT rcWndSnap, rcTemp, rcWndTemp, rcTempDst;
	BOOL bRet = FALSE;

	// make sure the target is OK
	if (hwndTarget == NULL)				return FALSE;
	if (!IsWindow(hwndTarget))			return FALSE;
	if (!IsWindowVisible(hwndTarget))	return FALSE;

	::GetWindowRect(hwndTarget, &rcWndSnap);

	// right side
	rcTemp = rcWndSnap;
	rcTemp.left = rcWndSnap.right - snaplen;
	rcTemp.right = rcWndSnap.right + snaplen;
	rcWndTemp = *lprcWnd;
	rcWndTemp.right = rcWndTemp.left+1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		int yOffset = 0;
		int topDif = lprcWnd->top - rcWndSnap.top;
		int bottomDif = rcWndSnap.bottom - lprcWnd->bottom;

		// snaps the edges (top and bottom)
		if (0 < topDif && topDif < snaplen)
		{
			yOffset = -topDif;
		}
		else if (0 < bottomDif && bottomDif < snaplen)
		{
			yOffset = bottomDif;
		}

		OffsetRect(lprcWnd, rcWndSnap.right - lprcWnd->left, yOffset);
		bRet = TRUE;
	}

	// left side
	rcTemp = rcWndSnap;
	rcTemp.left = rcWndSnap.left - snaplen;
	rcTemp.right = rcWndSnap.left + snaplen;
	rcWndTemp = *lprcWnd;
	rcWndTemp.left = rcWndTemp.right-1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		int yOffset = 0;
		int topDif = lprcWnd->top - rcWndSnap.top;
		int bottomDif = rcWndSnap.bottom - lprcWnd->bottom;

		// snaps the edges (top and bottom)
		if (0 < topDif && topDif < snaplen)
		{
			yOffset = -topDif;
		}
		else if (0 < bottomDif && bottomDif < snaplen)
		{
			yOffset = bottomDif;
		}

		OffsetRect(lprcWnd, rcWndSnap.left - lprcWnd->right, yOffset);
		bRet = TRUE;
	}

	// top side
	rcTemp = rcWndSnap;
	rcTemp.top = rcWndSnap.top - snaplen;
	rcTemp.bottom = rcWndSnap.top + snaplen;
	rcWndTemp = *lprcWnd;
	rcWndTemp.top = rcWndTemp.bottom-1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		int xOffset = 0;
		int leftDif = lprcWnd->left - rcWndSnap.left;
		int rightDif = rcWndSnap.right - lprcWnd->right;

		// snaps the edges (left and right)
		if (0 < leftDif && leftDif < snaplen)
		{
			xOffset = -leftDif;
		}
		else if (0 < rightDif && rightDif < snaplen)
		{
			xOffset = rightDif;
		}

		OffsetRect(lprcWnd, xOffset, rcWndSnap.top - lprcWnd->bottom);
		bRet = TRUE;
	}

	// bottom side
	rcTemp = rcWndSnap;
	rcTemp.top = rcWndSnap.bottom - snaplen;
	rcTemp.bottom = rcWndSnap.bottom + snaplen;
	rcWndTemp = *lprcWnd;
	rcWndTemp.bottom = rcWndTemp.top+1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		int xOffset = 0;
		int leftDif = lprcWnd->left - rcWndSnap.left;
		int rightDif = rcWndSnap.right - lprcWnd->right;

		// snaps the edges (left and right)
		if (0 < leftDif && leftDif < snaplen)
		{
			xOffset = -leftDif;
		}
		else if (0 < rightDif && rightDif < snaplen)
		{
			xOffset = rightDif;
		}

		OffsetRect(lprcWnd, xOffset, rcWndSnap.bottom - lprcWnd->top);
		bRet = TRUE;
	}

	// upper-right corner
	rcTemp.top = rcWndSnap.bottom;
	rcTemp.bottom = rcWndSnap.bottom + CORNER_SNAP_LEN;
	rcTemp.left = rcWndSnap.left - CORNER_SNAP_LEN;
	rcTemp.right = rcWndSnap.left;
	rcWndTemp = *lprcWnd;
	rcWndTemp.bottom = rcWndTemp.top + 1;
	rcWndTemp.left = rcWndTemp.right - 1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		OffsetRect(lprcWnd, rcWndSnap.left - lprcWnd->right, rcWndSnap.bottom - lprcWnd->top);
		bRet = TRUE;
	}

	// lower-right corner
	rcTemp.top = rcWndSnap.top - CORNER_SNAP_LEN;
	rcTemp.bottom = rcWndSnap.top;
	rcTemp.left = rcWndSnap.left - CORNER_SNAP_LEN;
	rcTemp.right = rcWndSnap.left;
	rcWndTemp = *lprcWnd;
	rcWndTemp.top = rcWndTemp.bottom - 1;
	rcWndTemp.left = rcWndTemp.right - 1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		OffsetRect(lprcWnd, rcWndSnap.left - lprcWnd->right, rcWndSnap.top - lprcWnd->bottom);
		bRet = TRUE;
	}

	// lower-left corner
	rcTemp.top = rcWndSnap.top - CORNER_SNAP_LEN;
	rcTemp.bottom = rcWndSnap.top;
	rcTemp.left = rcWndSnap.right;
	rcTemp.right = rcWndSnap.right + CORNER_SNAP_LEN;
	rcWndTemp = *lprcWnd;
	rcWndTemp.top = rcWndTemp.bottom - 1;
	rcWndTemp.right = rcWndTemp.left + 1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		OffsetRect(lprcWnd, rcWndSnap.right - lprcWnd->left, rcWndSnap.top - lprcWnd->bottom);
		bRet = TRUE;
	}

	// upper-left corner
	rcTemp.top = rcWndSnap.bottom;
	rcTemp.bottom = rcWndSnap.bottom + CORNER_SNAP_LEN;
	rcTemp.left = rcWndSnap.right;
	rcTemp.right = rcWndSnap.right + CORNER_SNAP_LEN;
	rcWndTemp = *lprcWnd;
	rcWndTemp.bottom = rcWndTemp.top + 1;
	rcWndTemp.right = rcWndTemp.left + 1;
	if (IntersectRect(&rcTempDst, &rcTemp, &rcWndTemp))
	{
		OffsetRect(lprcWnd, rcWndSnap.right - lprcWnd->left, rcWndSnap.bottom - lprcWnd->top);
		bRet = TRUE;
	}
	return bRet;
}

void CWinampUI::NextWindow(int nPanel)
{
	HWND n[4];

	switch (nPanel)
	{
	case PANEL_AL:	n[0] = m_hWinamp;   n[1] = m_hWinampEQ; n[2] = m_hWinampPE; n[3] = m_hWinampMB; break;
	case PANEL_PE:	n[0] = m_hWinampMB; n[1] = m_hWnd;      n[2] = m_hWinamp;   n[3] = m_hWinampEQ; break;
	case PANEL_EQ:	n[0] = m_hWinampPE; n[1] = m_hWinampMB; n[2] = m_hWnd;      n[3] = m_hWinamp;   break;
	case PANEL_MB:	n[0] = m_hWnd;      n[1] = m_hWinamp;   n[2] = m_hWinampEQ; n[3] = m_hWinampPE; break;
	case PANEL_MN:	n[0] = m_hWinampEQ; n[1] = m_hWinampPE; n[2] = m_hWinampMB; n[3] = m_hWnd;      break;
	default:
		return;
	}

	for (int i=0; i<4; i++)
	{
		if (IsWindowVisible(n[i]))
		{
			SetFocus(n[i]);
			return;
		}
	}
}

BOOL CWinampUI::LButtonDown(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// close rectangle
	if (m_wafClose.PtInFunction(point, &rcWnd))
	{
		m_wafClose.Clicked(point);
		SetCapture(m_hWnd);
		DrawInterface();

		return TRUE;
	}

	// winshade mode toggle
	if (m_wafWinshade.PtInFunction(point, &rcWnd))
	{
		m_wafWinshade.Clicked(point);
		SetCapture(m_hWnd);
		DrawInterface();

		return TRUE;
	}

	// dragging rectangle
	if (m_wafDrag.PtInFunction(point, &rcWnd) || easymove)
	{
		// BASSFIX
		const bool controlDown = (::GetKeyState(VK_CONTROL) & 0x8000) != 0;
		if (controlDown) {
			m_wafDrag.Clicked(point);
			SetCapture(m_hWnd);
		}
		return TRUE;
	}

	return FALSE;
}

BOOL CWinampUI::LButtonUp(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	if (m_wafClose.IsClicked())
	{
		m_wafClose.Release();
		ReleaseCapture();
		if (m_wafClose.PtInFunction(point, &rcWnd))
		{
			al_open = 0;
			ShowWindow(m_hWnd, SW_HIDE);
		}

		return TRUE;
	}

	if (m_wafWinshade.IsClicked())
	{
		m_wafWinshade.Release();
		ReleaseCapture();
		if (m_wafWinshade.PtInFunction(point, &rcWnd))
		{
			WinshadeMode(!al_ws);
			DrawInterface();
		}

		return TRUE;
	}

	if (m_wafDrag.IsClicked())
	{
		m_wafDrag.Release();
		ReleaseCapture();

		return TRUE;
	}

	return FALSE;
}

BOOL CWinampUI::LButtonDblClk(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// winshade mode toggle
	if (m_wafDrag.PtInFunction(point, &rcWnd))
	{
		WinshadeMode(!al_ws);

		return TRUE;
	}

	return FALSE;
}

BOOL CWinampUI::RButtonUp(UINT nFlags, POINT point)
{
	return FALSE;
}

BOOL CWinampUI::MouseMove(UINT nFlags, POINT point)
{
	ChooseCursor(point);

	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	//Moving Code
	if (m_wafDrag.IsClicked())
	{
		RECT rcWnd;
		GetWindowRect(m_hWnd, &rcWnd);

		OffsetRect(&rcWnd, point.x - m_wafDrag.m_ptDown.x, point.y - m_wafDrag.m_ptDown.y);

		if (snap)
		{
			SnapDesktop(point, &rcWnd);
			SnapWindow(m_hWinampMB, &rcWnd);
			SnapWindow(m_hWinampEQ, &rcWnd);
			SnapWindow(m_hWinampPE, &rcWnd);
			SnapWindow(m_hWinamp, &rcWnd);

			HWND hWnd = NULL;

			// Nullsoft Advanced Visualization Studio (AVS)
			if (hWnd = ALFindWindow("avswnd", NULL)) SnapWindow(hWnd, &rcWnd);

			// Winamp Lyrics Plugin
			// Carlos Andres Osorio G
			// cosorio@mail.com
			// http://cosorio.cjb.net
			if (hWnd = ALFindWindow("TWinampLyrics", NULL)) SnapWindow(hWnd, &rcWnd);
			if (hWnd = ALFindWindow("TWinampLY", NULL)) SnapWindow(hWnd, &rcWnd);

			// Amarok Plugin
			// Christer Sundin
			// amarok@sundin.nu
			if (hWnd = ALFindWindow("AmarokPluginWindow", NULL)) SnapWindow(hWnd, &rcWnd);

			// Show Cover Plugin
			// Christian Larsen
			// christianlarsen@get2net.dk
			// http://w1.1981.telia.com/~u198103892/
			if (hWnd = ALFindWindow("Winamp SC", NULL)) SnapWindow(hWnd, &rcWnd);

			// Lyrics Plugin for Winamp
			// Josef Kyrian
			// jkyri@volny.cz
			// http://dynawest.cz/jkyri/lyrics/
			if (hWnd = ALFindWindow("Winamp LY", NULL)) SnapWindow(hWnd, &rcWnd);
		}

		SetWindowPos(m_hWnd, NULL, rcWnd.left, rcWnd.top, 0, 0, SWP_NOZORDER|SWP_NOSIZE);

		return TRUE;
	}	

	// close rectangle
	if (m_wafClose.IsClicked())
	{
		m_wafClose.PtInFunction(point, &rcWnd);
		DrawInterface();

		return TRUE;
	}

	// winshade rectangle
	if (m_wafWinshade.IsClicked())
	{
		m_wafWinshade.PtInFunction(point, &rcWnd);
		DrawInterface();

		return TRUE;
	}

	return FALSE;
}

void CWinampUI::MouseWheel(WORD fwKeys, short zDelta, POINT point)
{
}

void CWinampUI::HScroll(int nScrollCode, short int nPos, HWND hwndScrollBar)
{
	// not playing
	if (SendMessage(m_hWinamp, WM_WA_IPC, 0, IPC_ISPLAYING) == 0) return;

	int nCurPos = SendMessage(m_hWinamp, WM_WA_IPC, 0, IPC_GETOUTPUTTIME);
	int nLength = SendMessage(m_hWinamp, WM_WA_IPC, 1, IPC_GETOUTPUTTIME);

	int nDelta = (nLength * SCAN_PERCENTAGE) / 100;

	// forward/backward scan in song position
	switch (nScrollCode)
	{
	case SB_LINELEFT:	// backward scan
		nCurPos -= nDelta;
		if (nCurPos < 0) nCurPos = 0;
		SendMessage(m_hWinamp, WM_WA_IPC, nCurPos, IPC_JUMPTOTIME);
		break;

	case SB_LINERIGHT:	// forward scan
		nCurPos += nDelta;
		if (nCurPos > nLength) nCurPos = nLength;
		SendMessage(m_hWinamp, WM_WA_IPC, nCurPos, IPC_JUMPTOTIME);
		break;
	}
}

int CALLBACK EnumFontFamExProc(ENUMLOGFONTEX *lpelfe, NEWTEXTMETRICEX *lpntme, int FontType,  LPARAM lParam)
{
	BOOL *bAvail = (BOOL*)lParam;

	*bAvail = TRUE;

	return TRUE;
}
 
BOOL CWinampUI::ContextMenu(HWND hWnd, POINT point)
{
	HDC hdc = GetDC(hWnd);

	LOGFONT lf;

	BOOL bChineseBig5 = FALSE;
	BOOL bGB2312 = FALSE;
	BOOL bShiftJIS = FALSE;
	BOOL bHangul = FALSE;

	lf.lfFaceName[0] = 0;
	lf.lfPitchAndFamily = 0;

	char szLangID[4] = "\0\0\0";
	LCID lcid = GetUserDefaultLCID();
	GetLocaleInfo (lcid, LOCALE_SABBREVLANGNAME, szLangID, 4);

	// Traditional Chinese
	if (lstrcmpi(szLangID, "cht"))
	{
		lf.lfCharSet = CHINESEBIG5_CHARSET;
		EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)EnumFontFamExProc, (LPARAM)&bChineseBig5, 0);
	}

	// Simplified Chinese
	if (lstrcmpi(szLangID, "chs"))
	{
		lf.lfCharSet = GB2312_CHARSET;		
		EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)EnumFontFamExProc, (LPARAM)&bGB2312, 0);
	}

	// Japanese
	if (lstrcmpi(szLangID, "jpn"))
	{
		lf.lfCharSet = SHIFTJIS_CHARSET;	
		EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)EnumFontFamExProc, (LPARAM)&bShiftJIS, 0);
	}

	// Korean
	if (lstrcmpi(szLangID, "kor"))
	{
		lf.lfCharSet = HANGUL_CHARSET;		
		EnumFontFamiliesEx(hdc, &lf, (FONTENUMPROC)EnumFontFamExProc, (LPARAM)&bHangul, 0);
	}

	ReleaseDC(hWnd, hdc);
 	
	HMENU hMenu = CreatePopupMenu();

	// play all albums
	AppendMenu(hMenu, MF_STRING, IDC_PLAY_ALL_ALBUM, ALSTRING("Play &All Albums"));
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);

	// export albums
	AppendMenu(hMenu, MF_STRING, IDC_EXPORTLIST, ALSTRING("&Generate HTML list", "\tCtrl+E"));
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);

	// language sub-menu
	HMENU hMenuLanguage = NULL;
	if (m_pWinampAL->m_LangArray.GetSize())
	{
		int sel = IDC_LANGUAGE_ENGLISH;

		hMenuLanguage = CreatePopupMenu();
		AppendMenu(hMenuLanguage, MF_STRING, IDC_LANGUAGE_ENGLISH, "English");

		int size = m_pWinampAL->m_LangArray.GetSize();
		for (int i=0; i<size; i++)
		{
			LPLANGINFO pLangInfo = (LPLANGINFO)m_pWinampAL->m_LangArray[i];
			AppendMenu(hMenuLanguage, MF_STRING, IDC_LANGUAGE+i, pLangInfo->language);
			if (lstrcmpi(szLangINI, pLangInfo->pathname) == 0)
			{
				sel = IDC_LANGUAGE + i;
			}
		}
		CheckMenuItem(hMenuLanguage, sel, MF_BYCOMMAND|MF_CHECKED);

		AppendMenu(hMenu, MF_POPUP, (UINT)hMenuLanguage, ALSTRING("&Language"));
	}

	// encoding sub-menu
	HMENU hMenuEncoding = NULL;
	if (bChineseBig5 || bGB2312 || bShiftJIS || bHangul)
	{
		hMenuEncoding = CreatePopupMenu();
		AppendMenu(hMenuEncoding, MF_STRING, IDC_LANGUAGE_ENU, ALSTRING("&System Default"));
		if (bChineseBig5)	AppendMenu(hMenuEncoding, MF_STRING, IDC_LANGUAGE_CHT, ALSTRING("&Traditional Chinese"));
		if (bGB2312)		AppendMenu(hMenuEncoding, MF_STRING, IDC_LANGUAGE_CHS, ALSTRING("&Simplified Chinese"));
		if (bShiftJIS)		AppendMenu(hMenuEncoding, MF_STRING, IDC_LANGUAGE_JPN, ALSTRING("&Japanese"));
		if (bHangul)		AppendMenu(hMenuEncoding, MF_STRING, IDC_LANGUAGE_KOR, ALSTRING("&Korean"));

		CheckMenuItem(hMenuEncoding, al_language, MF_BYCOMMAND|MF_CHECKED);

		AppendMenu(hMenu, MF_POPUP, (UINT)hMenuEncoding, ALSTRING("&Encoding"));
	}

	// sort sub-menu
	HMENU hMenuSort = CreatePopupMenu();
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_OFF, ALSTRING("&Off"));
	AppendMenu(hMenuSort, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_PATH, ALSTRING("Sort list by &path"));
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_NAME, ALSTRING("Sort list by &display name"));
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_ARTIST, ALSTRING("Sort list by &artist name"));
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_YEAR, ALSTRING("Sort list by &year"));
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_NUMOFSONGS, ALSTRING("Sort list by &number of tracks"));
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_TOTALTIME, ALSTRING("Sort list by album total &time"));
	AppendMenu(hMenuSort, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenuSort, MF_STRING, IDC_SORT_SHUFFLE, ALSTRING("&Shuffle albums"));

	CheckMenuItem(hMenuSort, al_sortalbum + IDC_SORT_OFF, MF_BYCOMMAND|MF_CHECKED);

	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuSort, ALSTRING("&Sort"));

	// time sub-menu
	HMENU hMenuTime = CreatePopupMenu();
	AppendMenu(hMenuTime, MF_STRING, IDC_TIMEFORMAT0, ALSTRING("&Off"));
	AppendMenu(hMenuTime, MF_STRING, IDC_TIMEFORMAT1, ALSTRING("Show album total time in &h:mm:ss"));
	AppendMenu(hMenuTime, MF_STRING, IDC_TIMEFORMAT2, ALSTRING("Show album total time in &mmm:ss"));
	AppendMenu(hMenuTime, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenuTime, MF_STRING, IDC_TIMEFORMAT3, ALSTRING("Show &number of songs in album (nn)"));
	AppendMenu(hMenuTime, MF_STRING, IDC_SHOW_YEAR, ALSTRING("Show album &year - yyyy"));

	CheckMenuItem(hMenuTime, al_timeformat + IDC_TIMEFORMAT0, MF_BYCOMMAND|MF_CHECKED);
	if (al_shownum) CheckMenuItem(hMenuTime, IDC_TIMEFORMAT3, MF_BYCOMMAND|MF_CHECKED);
	if (al_showyear) CheckMenuItem(hMenuTime, IDC_SHOW_YEAR, MF_BYCOMMAND|MF_CHECKED);

	AppendMenu(hMenu, MF_POPUP, (UINT)hMenuTime, ALSTRING("Status &display"));

	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
	AppendMenu(hMenu, MF_STRING, IDC_REFRESH, ALSTRING("Re&fresh", "\tCtrl+R"));
	AppendMenu(hMenu, MF_STRING, IDC_REFRESH_QUICK, ALSTRING("Refresh (&Quick)", "\tF5"));
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);

	AppendMenu(hMenu, MF_STRING, IDC_JUMPTOALBUM, ALSTRING("&Jump to album", "\tJ, F3"));
	AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);

	AppendMenu(hMenu, MF_STRING, IDC_SHOW_PROPERTIES, ALSTRING("P&roperties...", "\tCtrl+P"));

	// menu key fix
	if ((point.x == -1) && (point.y == -1))
	{
		RECT rc;
		GetWindowRect(m_hWnd, &rc);
		point.x = rc.left + 13;
		point.y = rc.top + 22;
	}

	DWORD dwFlags = TPM_LEFTALIGN|TPM_RETURNCMD|TPM_NONOTIFY|TPM_RIGHTBUTTON|TPM_LEFTBUTTON;
	UINT nRet = TrackPopupMenu(hMenu, dwFlags, point.x, point.y, 0, m_hWnd, NULL);
	switch (nRet)
	{
	// play all albums
	case IDC_PLAY_ALL_ALBUM:
		PlayAllAlbums();
		break;

	case IDC_EXPORTLIST:
		ExportList();
		break;

	// encoding
	case IDC_LANGUAGE_ENU:
	case IDC_LANGUAGE_CHT:
	case IDC_LANGUAGE_CHS:
	case IDC_LANGUAGE_JPN:
	case IDC_LANGUAGE_KOR:
		al_language = nRet;
		m_pWinampAL->m_waNormal.RefreshFont();
		m_pWinampAL->m_waWinshade.RefreshFont();
		DrawInterface();
		break;

	// sort
	case IDC_SORT_OFF:
		al_sortalbum = nRet - IDC_SORT_OFF;
		break;
	case IDC_SORT_PATH:
	case IDC_SORT_NAME:
	case IDC_SORT_ARTIST:
	case IDC_SORT_YEAR:
	case IDC_SORT_NUMOFSONGS:
	case IDC_SORT_TOTALTIME:
	case IDC_SORT_SHUFFLE:
		al_sortalbum = nRet - IDC_SORT_OFF;
		Sort();
		break;

	// time
	case IDC_TIMEFORMAT0:
	case IDC_TIMEFORMAT1:
	case IDC_TIMEFORMAT2:
		al_timeformat = nRet - IDC_TIMEFORMAT0;
		DrawInterface();
		break;

	case IDC_TIMEFORMAT3:
		al_shownum = !al_shownum;
		DrawInterface();
		break;

	case IDC_SHOW_YEAR:
		al_showyear = !al_showyear;
		DrawInterface();
		break;

	case IDC_REFRESH:
		m_pWinampAL->RefreshAlbums();
		break;

	case IDC_REFRESH_QUICK:
		m_pWinampAL->RefreshAlbums(TRUE/*QuickRefresh*/);
		break;

	case IDC_JUMPTOALBUM:
		DialogBox(plugin.hDllInstance, MAKEINTRESOURCE(IDD_JUMPTOALBUM), m_hWnd, JumpToAlbumProc);
		break;
	}

	if (hMenuEncoding) DestroyMenu(hMenuEncoding);
	if (hMenuLanguage) DestroyMenu(hMenuLanguage);
	DestroyMenu(hMenuSort);
	DestroyMenu(hMenu);

	if (nRet == IDC_SHOW_PROPERTIES)
	{
		void config();
		config();
	}
	else if (nRet == IDC_LANGUAGE_ENGLISH)
	{
		lstrcpy(al_lang, "%default%");
		lstrcpy(szLangINI, "");

		m_pWinampAL->RefreshSkin();
		m_pWinampAL->m_waNormal.RefreshFont();
		m_pWinampAL->m_waWinshade.RefreshFont();
	}
	else if ((IDC_LANGUAGE <= nRet) && (nRet <= IDC_LANGUAGE_LAST))
	{
		int idx = nRet - IDC_LANGUAGE;
		if (idx < m_pWinampAL->m_LangArray.GetSize())
		{
			LPLANGINFO pLangInfo = (LPLANGINFO)m_pWinampAL->m_LangArray[idx];

			lstrcpy(al_lang, pLangInfo->filename);
			lstrcpy(szLangINI, pLangInfo->pathname);
		}

		m_pWinampAL->RefreshSkin();
		m_pWinampAL->m_waNormal.RefreshFont();
		m_pWinampAL->m_waWinshade.RefreshFont();
	}

	return TRUE;
}

void CWinampUI::Sort()
{
	if (al_sortalbum == 7)
	{
		m_pAlbumList->ShuffleAlbums();
	}
	else
	{
		m_pAlbumList->Resort();
	}
	DrawInterface();
}

void CWinampUI::RefreshFont()
{
	if (m_hFont) DeleteObject(m_hFont);
	if (m_hFontPE) DeleteObject(m_hFontPE);
	m_hFont = NULL;
	m_hFontPE = NULL;

	int fontsize = al_fontsize ? al_fontsize : pe_fontsize;

	// create font for albumlist
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = fontsize + 3;
	lf.lfCharSet = DEFAULT_CHARSET;
	strcpy(lf.lfFaceName, color_font);

	switch (al_language)
	{
	case IDC_LANGUAGE_ENU:	lf.lfHeight  = -fontsize;			break;
	case IDC_LANGUAGE_CHT:	lf.lfCharSet = CHINESEBIG5_CHARSET;	break;
	case IDC_LANGUAGE_CHS:	lf.lfCharSet = GB2312_CHARSET;		break;
	case IDC_LANGUAGE_JPN:	lf.lfCharSet = SHIFTJIS_CHARSET;	break;
	case IDC_LANGUAGE_KOR:	lf.lfCharSet = HANGUL_CHARSET;		break;
	}

	m_hFont = CreateFontIndirect(&lf);

	// create font for playlist editor
	lf.lfHeight = (al_language == IDC_LANGUAGE_ENU) ? -pe_fontsize : pe_fontsize + 3;

	m_hFontPE = CreateFontIndirect(&lf);

#if 0	// really no needed?? trust T-Matsuo on this one...
	// If this system is using a double byte language we must ensure
	// that the font we have supports a double byte characterset:
	if (GetSystemMetrics (SM_DBCSENABLED))
	{
		char szLangID[4] = "\0\0\0";
		LCID lcid = GetUserDefaultLCID();
		GetLocaleInfo (lcid, LOCALE_SABBREVLANGNAME, szLangID, 4);

		// do this only in Japanese
		if (lstrcmpi(szLangID, "jpn") == 0)
		{
			HDC hDC = GetDC(m_hWnd);
			if (hDC)
			{
				HFONT hFont = (HFONT)SelectObject(hDC, m_hFont);
				DWORD dwFontLang = GetFontLanguageInfo(hDC);
				SelectObject(hDC, hFont);

				if ((dwFontLang & GCP_DBCS) != GCP_DBCS)
				{
					// This is not a double byte font - recreate an appropriate one:
					DeleteObject(m_hFont);
					DeleteObject(m_hFontPE);

					lf.lfHeight = fontsize + 3;
					lf.lfCharSet = SHIFTJIS_CHARSET;
					strcpy(lf.lfFaceName, "MS Sans Serif");
					m_hFont = CreateFontIndirect(&lf);
				
					lf.lfHeight = (al_language == IDC_LANGUAGE_ENU) ? -pe_fontsize : pe_fontsize + 3;
					m_hFontPE = CreateFontIndirect(&lf);
				}

				ReleaseDC(m_hWnd, hDC);
			}
		}
	}
#endif

	InvalidateRect(m_hWinampPE, NULL, TRUE);
	UpdateWindow(m_hWinampPE);
}

void CWinampUI::AddEndEllipsis(HDC hdc, WCHAR *str, int width)
{
	WCHAR ellipsis[] = L"...";
	SIZE szStr, szEllipsis;
	int len = wcslen(str);

	GetTextExtentPoint32W(hdc, str, len, &szStr);
	GetTextExtentPoint32W(hdc, ellipsis, wcslen(ellipsis), &szEllipsis);

	BOOL bChanged = FALSE;
	while (szStr.cx > width)
	{
		len --;
		GetTextExtentPoint32W(hdc, str, len, &szStr);
		szStr.cx += szEllipsis.cx;
		bChanged = TRUE;
	}

	if (bChanged)
	{
		str[len] = L'\0';
		lstrcatW(str, ellipsis);
	}
}

void CWinampUI::TextOutUnicode(HDC hdc, RECT *lprc, int cp, char *szAlbum, char *szTime, char *szTimeFormat)
{
	SIZE size;

	WCHAR szAlbumW[128], szTimeW[32], szTimeFormatW[32];

	MultiByteToWideChar(cp, MB_PRECOMPOSED, szAlbum, -1/*lstrlen(szAlbum)*/, szAlbumW, 128);
	MultiByteToWideChar(cp, MB_PRECOMPOSED, szTime, -1/*lstrlen(szTime)*/, szTimeW, 32);
	MultiByteToWideChar(cp, MB_PRECOMPOSED, szTimeFormat, -1/*lstrlen(szTimeFormat)*/, szTimeFormatW, 32);

	GetTextExtentPoint32W(hdc, szTimeFormatW, wcslen(szTimeFormatW), &size);

	AddEndEllipsis(hdc, szAlbumW, lprc->right - size.cx - 2 - lprc->left);

	// draw album name
	ExtTextOutW(hdc, lprc->left, lprc->top, ETO_CLIPPED, lprc, szAlbumW, wcslen(szAlbumW), NULL);

	// draw time
	GetTextExtentPoint32W(hdc, szTimeW, wcslen(szTimeW), &size);
	ExtTextOutW(hdc, lprc->right - size.cx, lprc->top, ETO_CLIPPED, lprc, szTimeW, wcslen(szTimeW), NULL);
}

int CWinampUI::DrawTextUnicode(HDC hDC, LPCTSTR lpString, int nCount, LPRECT lpRect, UINT uFormat)
{
	int cp = 0;

	if (WindowFromDC(hDC) != m_hWinampPE) return 0;

	switch (al_language)
	{
	case IDC_LANGUAGE_ENU:
		return 0;
			
	case IDC_LANGUAGE_CHT:	cp = 950;	break;
	case IDC_LANGUAGE_CHS:	cp = 936;	break;
	case IDC_LANGUAGE_JPN:	cp = 932;	break;
	case IDC_LANGUAGE_KOR:	cp = 949;	break;

	default:
		return 0;
	}

	if (nCount == -1) nCount = lstrlen(lpString);

	HFONT hOldFont = (HFONT)SelectObject(hDC, m_hFontPE);

	WCHAR *lpStringW = new WCHAR [nCount + 1];

	MultiByteToWideChar(cp, MB_PRECOMPOSED, lpString, -1/*lstrlen(szAlbum)*/, lpStringW, nCount + 1);

	SIZE szStr;
	GetTextExtentPoint32W(hDC, lpStringW, nCount, &szStr);

	if (uFormat & DT_CALCRECT)
	{
		if ((lpRect->left + szStr.cx) < lpRect->right)
			lpRect->right = lpRect->left + szStr.cx;
		return szStr.cy;
	}

	if (uFormat & DT_END_ELLIPSIS)
	{
		AddEndEllipsis(hDC, lpStringW, lpRect->right - lpRect->left);
	}

	int xOffset = 0;
	DWORD dwTA = GetTextAlign(hDC);
	if (GetTextAlign(hDC) & TA_RIGHT)
	{
		xOffset = lpRect->right - lpRect->left - szStr.cx;
	}

	int nRet = ExtTextOutW(hDC, lpRect->left + xOffset, lpRect->top, ETO_CLIPPED|ETO_OPAQUE, lpRect, lpStringW, wcslen(lpStringW), NULL);
	if (nRet) nRet = szStr.cy;

	DWORD dwLastError = GetLastError();
 
	delete [] lpStringW;

	SelectObject(hDC, hOldFont);

	return nRet;
}

void CWinampUI::DrawBitmapFont(HDC hdc, RECT rcTemp, const char *str, BOOL bLeftAligned/*=TRUE*/, BOOL bFill/*=FALSE*/)
{
	HDC memDC = CreateCompatibleDC(hdc);
	HBITMAP hOldBmp = (HBITMAP)SelectObject(memDC, m_hBmpText);

	int x, y;
	if (bLeftAligned)
	{
		x = rcTemp.left;
		y = rcTemp.top;
	}
	else
	{
		x = rcTemp.right - lstrlen(str) * 5;
		y = rcTemp.top;
	}

	int i=0;
	int len=lstrlen(str);
	while (str[i])
	{
		int nIndex = 29;
		int ch = (unsigned char)str[i];
		if (isdigit(ch)) nIndex = 30 + ch - '0';
		else if (isalpha(ch)) nIndex = 0 + ch - (isupper(ch) ? 'A' : 'a');
		else
		{
			switch (ch)
			{
			case '"':	nIndex = 26;	break;
			case '@':	nIndex = 27;	break;
			case '.':	nIndex = 41;	break;
			case ':':	nIndex = 42;	break;
			case '(':	nIndex = 43;	break;
			case ')':	nIndex = 44;	break;
			case '-':	nIndex = 45;	break;
			case '\'':	nIndex = 46;	break;
			case '`':	nIndex = 46;	break;
			case '!':	nIndex = 47;	break;
			case '_':	nIndex = 48;	break;
			case '+':	nIndex = 49;	break;
			case '\\':	nIndex = 50;	break;
			case '/':	nIndex = 51;	break;
			case '[':	nIndex = 52;	break;
			case ']':	nIndex = 53;	break;
			case '^':	nIndex = 54;	break;
			case '&':	nIndex = 55;	break;
			case '%':	nIndex = 56;	break;
			case ',':	nIndex = 57;	break;
			case '=':	nIndex = 58;	break;
			case '$':	nIndex = 59;	break;
			case '#':	nIndex = 60;	break;
			case '':	nIndex = 61;	break;
			case '':	nIndex = 62;	break;
			case '':	nIndex = 63;	break;
			case '?':	nIndex = 64;	break;
			case '*':	nIndex = 65;	break;
			case ' ':	nIndex = 66;	break;
			default:	nIndex = 29;	break;
			}
		}

		// change to "..." if too long
		if ((x+15) >= rcTemp.right)
		{
			if (len > 3)
			{
				BitBlt(hdc, x, y, 5, 6, memDC, rcTextBmp[40].left, rcTextBmp[40].top, SRCCOPY);
				BitBlt(hdc, x+5, y, 5, 6, memDC, rcTextBmp[66].left, rcTextBmp[66].top, SRCCOPY);
				x += 15;
				break;
			}
		}

		BitBlt(hdc, x, y, 5, 6, memDC, rcTextBmp[nIndex].left, rcTextBmp[nIndex].top, SRCCOPY);
		x += 5;
		i++;
		len--;
	}

	if (bLeftAligned && bFill)
	{
		while (x < rcTemp.right)
		{
			BitBlt(hdc, x, y, 5, 6, memDC, rcTextBmp[66].left, rcTextBmp[29].top, SRCCOPY);
			x += 5;
		}
	}

	SelectObject(memDC, hOldBmp);
	DeleteDC(memDC);
}

void CWinampUI::FixTitles(char *str)
{
	// no need to fix title
	if (fixtitles == 0) return;

	int len = lstrlen(str);

	for (int i=0; i<len; i++)
	{
		// convert %20 to space in titles
		if ((fixtitles & 1) && (str[i] == '%'))
		{
			char temp[4];
			lstrcpyn(temp, str+i, 4);
			if (lstrcmp(temp, "%20") == 0)
			{
				str[i] = ' ';

				// move the remaining characters forward
				for (int j=i+3; j<len; j++)
				{
					str[j-2] = str[j];
				}

				// adjust the length
				len -= 2;
				str[len] = 0;
			}
		}

		// convert underscore to space in titles
		if ((fixtitles & 2) && (str[i] == '_'))
		{
			str[i] = ' ';
		}
	}
}

void CWinampUI::WinshadeMode(BOOL bOn)
{
	int top, left, width, height;

	al_ws = bOn;

	RECT rcWnd;
	GetWindowRect(m_hWnd, &rcWnd);

	top = rcWnd.top;
	left = rcWnd.left;

	if (al_ws)
	{
		// going into winshade mode
		al_width = rcWnd.right - rcWnd.left;
		al_height = rcWnd.bottom - rcWnd.top;

		width = al_width;
		height = WINSHADE_HEIGHT;

		m_pWinampAL->InitDocking(PANEL_PE);

		int docktop = GETDOCKTOP(m_pWinampAL->m_dwDocked[PANEL_AL]);
		int dockbottom = GETDOCKBOTTOM(m_pWinampAL->m_dwDocked[PANEL_AL]);

		if (docktop != 0xFF)
		{
			while (dockbottom != 0xFF)
			{
				HWND hWndDock = m_pWinampAL->m_hWndDock[dockbottom];
				RECT rcDock;
				GetWindowRect(hWndDock, &rcDock);

				int nOffset = al_height - WINSHADE_HEIGHT;

				SetWindowPos(hWndDock, NULL, rcDock.left, rcDock.top - nOffset, 0, 0, SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER);

				dockbottom = GETDOCKBOTTOM(m_pWinampAL->m_dwDocked[dockbottom]);
			}
		}
		else if (dockbottom != 0xFF)
		{
			RECT rcDock;
			GetWindowRect(m_pWinampAL->m_hWndDock[dockbottom], &rcDock);

			top = rcDock.top - WINSHADE_HEIGHT;
		}
		else
		{
			HMONITOR hCurMonitor = MonitorFromRect(&rcWnd, MONITOR_DEFAULTTONEAREST);
			MONITORINFO mi;
			mi.cbSize = sizeof(MONITORINFO);

			if (GetMonitorInfo(hCurMonitor, &mi))
			{
				if (rcWnd.bottom == mi.rcWork.bottom)
				{
					top = rcWnd.bottom - WINSHADE_HEIGHT;
				}
			}
		}
	}
	else
	{
		// restore to normal mode
		width = al_width = rcWnd.right - rcWnd.left;
		height = al_height;

		m_pWinampAL->InitDocking(PANEL_PE);

		int docktop = GETDOCKTOP(m_pWinampAL->m_dwDocked[PANEL_AL]);
		int dockbottom = GETDOCKBOTTOM(m_pWinampAL->m_dwDocked[PANEL_AL]);

		if (docktop != 0xFF)
		{
			while (dockbottom != 0xFF)
			{
				HWND hWndDock = m_pWinampAL->m_hWndDock[dockbottom];
				RECT rcDock;
				GetWindowRect(hWndDock, &rcDock);

				int nOffset = al_height - WINSHADE_HEIGHT;

				SetWindowPos(hWndDock, NULL, rcDock.left, rcDock.top + nOffset, 0, 0, SWP_NOACTIVATE|SWP_NOSIZE|SWP_NOZORDER);

				dockbottom = GETDOCKBOTTOM(m_pWinampAL->m_dwDocked[dockbottom]);
			}
		}
		else if (dockbottom != 0xFF)
		{
			RECT rcDock;
			GetWindowRect(m_pWinampAL->m_hWndDock[dockbottom], &rcDock);

			top = rcDock.top - al_height;
		}
		else
		{
			HMONITOR hCurMonitor = MonitorFromRect(&rcWnd, MONITOR_DEFAULTTONEAREST);
			MONITORINFO mi;
			mi.cbSize = sizeof(MONITORINFO);

			if (GetMonitorInfo(hCurMonitor, &mi))
			{
				if (rcWnd.bottom == mi.rcWork.bottom)
				{
					top = rcWnd.bottom - al_height;
				}
			}
		}
	}

	m_pWinampAL->m_pWinampUI = (al_ws == 0) ? (CWinampUI*)&m_pWinampAL->m_waNormal : (CWinampUI*)&m_pWinampAL->m_waWinshade;

	SetWindowPos(m_hWnd, NULL, left, top, width, height, SWP_NOACTIVATE|SWP_NOZORDER);
}

void CWinampUI::NextAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	if ((m_nCurrentSelection + 1) < m_pAlbumList->GetSize())
	{
		m_nCurrentSelection++;
		DrawInterface();
	}

	if (al_showcover) ShowAlbumInMiniBrowser(m_nCurrentSelection);
}

void CWinampUI::PrevAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	if (0 < m_nCurrentSelection)
	{
		m_nCurrentSelection--;
		DrawInterface();
	}
	else
	{
		m_nCurrentSelection = 0;
		DrawInterface();
	}

	if (al_showcover) ShowAlbumInMiniBrowser(m_nCurrentSelection);
}

void CWinampUI::ExportList()
{
	m_pAlbumList->ExportList();
}

void CWinampUI::SelectAlbum(int nIndex /*=-1*/)
{
	if (m_pAlbumList->GetSize() == 0) return;
	if (nIndex == -1) nIndex = m_nCurrentSelection;

	LPALBUMINFO album = m_pAlbumList->GetAlbum(nIndex);
	if (album == NULL) return;

	m_pAlbumList->PlayAlbum(album);
	DrawInterface();

	if (al_showcover) ShowAlbumInMiniBrowser(nIndex);
}

void CWinampUI::EnqueueAlbum(int nIndex /*=-1*/)
{
	if (m_pAlbumList->GetSize() == 0) return;
	if (nIndex == -1) nIndex = m_nCurrentSelection;

	LPALBUMINFO album = m_pAlbumList->GetAlbum(nIndex);
	if (album == NULL) return;

	m_pAlbumList->EnqueueAlbum(album);
	DrawInterface();

	if (al_showcover) ShowAlbumInMiniBrowser(nIndex);
}

void CWinampUI::EndAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	m_nCurrentSelection = m_pAlbumList->GetSize() - 1;
	DrawInterface();
}

void CWinampUI::HomeAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	m_nCurrentSelection = 0;
	DrawInterface();
}

void CWinampUI::PageUpAlbum()
{
}

void CWinampUI::PageDownAlbum()
{
}

void CWinampUI::MoveUp()
{
}

void CWinampUI::MoveDown()
{
}

void CWinampUI::PlayNextAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	// if this function return error, we will be playing the first song
	// since the error code is -1
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);

	if ((cindex + 1) < m_pAlbumList->GetSize())
	{
		cindex = cindex + 1;
	}
	else if (al_loop)
	{
		cindex = 0;
	}
	else
	{
		return;
	}

	LPALBUMINFO album = m_pAlbumList->GetAlbum(cindex);
	if (album == NULL) return;

	m_pAlbumList->PlayAlbum(album);
	DrawInterface();

	if (al_showcover) ShowAlbumInMiniBrowser(cindex);
}

void CWinampUI::PlayNextArtist()
{
	if (m_pAlbumList->GetSize() == 0) return;

	// if this function return error, we will be playing the first song
	// since the error code is -1
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	LPALBUMINFO album = m_pAlbumList->GetAlbum(cindex);

	char szArtist[MAX_PATH] = "";
	if (album) lstrcpy(szArtist, album->artist);

	while (1)
	{
		if ((cindex + 1) < m_pAlbumList->GetSize())
		{
			cindex = cindex + 1;
		}
		else if (al_loop)
		{
			cindex = 0;
		}
		else
		{
			return;
		}

		LPALBUMINFO album = m_pAlbumList->GetAlbum(cindex);
		if (album == NULL) return;
		if (lstrcmpi(szArtist, album->artist) == 0) continue;

		m_pAlbumList->PlayAlbum(album);
		DrawInterface();

		if (al_showcover) ShowAlbumInMiniBrowser(cindex);

		return;
	}
}

void CWinampUI::PlayPrevAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	// if this function return error, we will be playing the first song
	// since the error code is -1
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	if (cindex == -1) cindex = 1;

	if (0 < cindex)
	{
		cindex = cindex - 1;
	}
	else if (al_loop)
	{
		cindex = m_pAlbumList->GetSize() - 1;
	}
	else
	{
		return;
	}

	LPALBUMINFO album = m_pAlbumList->GetAlbum(cindex);
	if (album == NULL) return;

	m_pAlbumList->PlayAlbum(album);
	DrawInterface();

	if (al_showcover) ShowAlbumInMiniBrowser(cindex);
}

void CWinampUI::PlayPrevArtist()
{
	if (m_pAlbumList->GetSize() == 0) return;

	// if this function return error, we will be playing the first song
	// since the error code is -1
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	LPALBUMINFO album = m_pAlbumList->GetAlbum(cindex);
	if (cindex == -1) cindex = 1;

	char szArtist[MAX_PATH] = "";
	if (album) lstrcpy(szArtist, album->artist);

	while (1)
	{
		if (0 < cindex)
		{
			cindex = cindex - 1;
		}
		else if (al_loop)
		{
			cindex = m_pAlbumList->GetSize() - 1;
		}
		else
		{
			return;
		}

		LPALBUMINFO album = m_pAlbumList->GetAlbum(cindex);
		if (album == NULL) return;
		if (lstrcmpi(szArtist, album->artist) == 0) continue;

		m_pAlbumList->PlayAlbum(album);
		DrawInterface();

		if (al_showcover) ShowAlbumInMiniBrowser(cindex);

		return;
	}
}

void CWinampUI::PlayAllAlbums()
{
	int size = m_pAlbumList->GetSize();
	if (size)
	{
		m_pAlbumList->PlayAlbum(m_pAlbumList->GetAlbum(0));
		for (int i=1; i<size; i++)
		{
			m_pAlbumList->EnqueueAlbum(m_pAlbumList->GetAlbum(i));
		}
	}
}

void CWinampUI::ShowAlbumInMiniBrowser(int index)
{
	LPALBUMINFO pAlbumInfo = m_pAlbumList->GetAlbum(index);
	if (pAlbumInfo)
	{
		// create temperary playlist
		char tempfile[MAX_PATH] = "";
		if (GetTempPath(MAX_PATH, tempfile) == 0)
		{
			lstrcpy(tempfile, ".\\");
		}
		lstrcat(tempfile, "albumlist.htm");

		CTemplateFile templatefile;

		templatefile.AddReplace("backgroundcolor", (COLORREF)color_normalbg);

		//---------------------------
		// add bitmap links
		char *token = NULL;
		char seps[] = " ?,\"'~!.-:;\t\n";
		char string[MAX_PATH] = "";

		lstrcpyn(string, "jpg jpeg gif png", MAX_PATH);
		token = strtok(string, seps);

		CPictureArray CoverPictures;
		while( token != NULL )
		{
			char bmppath[MAX_PATH];
			lstrcpy(bmppath, pAlbumInfo->path);
			lstrcat(bmppath, "\\*.");
			lstrcat(bmppath, token);

			WIN32_FIND_DATA FindFileData;
			HANDLE hFile;

			if ((hFile = FindFirstFile(bmppath, &FindFileData)) != INVALID_HANDLE_VALUE)
			{
				do
				{
					char file[MAX_PATH*2];
					wsprintf(file, "%s\\%s", pAlbumInfo->path, FindFileData.cFileName);
			
					int len = lstrlen(file);
					for (int i=0; i<len; i++)
					{
						if (IsDBCSLeadByte(file[i]))
						{
							i++;
						}
						else if (file[i] == '\\')
						{
							file[i] = '/';
						}
					}

					LPPICTUREINFO pPicInfo = new PICTUREINFO;
					lstrcpy(pPicInfo->file, file);

					if (strnicmp(FindFileData.cFileName, "front.", 6) == 0)
					{
						pPicInfo->nType = 0;
					}
					else if (strnicmp(FindFileData.cFileName, "inside.", 7) == 0)
					{
						pPicInfo->nType = 1;
					}
					else if (strnicmp(FindFileData.cFileName, "cd.", 3) == 0)
					{
						pPicInfo->nType = 2;
					}
					else if (strnicmp(FindFileData.cFileName, "inlay.", 6) == 0)
					{
						pPicInfo->nType = 3;
					}
					else if (strnicmp(FindFileData.cFileName, "back.", 5) == 0)
					{
						pPicInfo->nType = 4;
					}
					else
					{
						pPicInfo->nType = 64;
					}

					CoverPictures.Add(pPicInfo);
				}
				while (FindNextFile(hFile, &FindFileData) != 0);

				FindClose(hFile);
			}
			// Get next token:
			token = strtok(NULL, seps);
		}

		CoverPictures.Sort();

		BOOL bFoundBitmap = FALSE;
		int size = CoverPictures.GetSize();
		for (int nCount=0; nCount<size; nCount++)
		{
			LPPICTUREINFO pPicInfo = CoverPictures[nCount];

			templatefile.AddReplace("slidepic", nCount, pPicInfo->file);
			bFoundBitmap = TRUE;

			delete pPicInfo;
		}
		CoverPictures.RemoveAll();

		//---------------------------
		// no bitmap found?
		if (!bFoundBitmap) return;

		//---------------------------
		// current album info
		char str[256];
		int hour = pAlbumInfo->nTotalTime/3600;
		int min = (pAlbumInfo->nTotalTime%3600)/60;
		int sec = pAlbumInfo->nTotalTime%60;

		if (hour)
			wsprintf(str, "%ld:%02ld:%02ld", hour, min, sec);
		else
			wsprintf(str, "%ld:%02ld", min, sec);

		templatefile.AddReplace("albumindex", index+1);
		templatefile.AddReplace("albumname", pAlbumInfo->album);
		templatefile.AddReplace("albumcount", pAlbumInfo->nCount);
		templatefile.AddReplace("displayname", pAlbumInfo->name);
		templatefile.AddReplace("albumartist", pAlbumInfo->artist);
		templatefile.AddReplace("albumyear", pAlbumInfo->nYear);
		templatefile.AddReplace("albumlengthhrs", hour);
		templatefile.AddReplace("albumlengthmin", min);
		templatefile.AddReplace("albumlengthsec", sec);
		templatefile.AddReplace("albumlength", str);

		//---------------------------
		// convert the file
		char szTemplateFile[MAX_PATH];
		wsprintf(szTemplateFile, "%s%s", szAlbumListDir, "Album List\\Templates\\cover.htt");
		if (!templatefile.Convert(tempfile, szTemplateFile)) return;

		//---------------------------
		// show the thing in the minibrowser
		HWND hWinampMB = ALFindWindow("Winamp MB", NULL);
		if (bFoundBitmap)
		{
			char url[MAX_PATH*2] = "file:///";
			lstrcat(url, tempfile);
			SendMessage(plugin.hwndParent, WM_WA_IPC, 0, IPC_MBOPEN);
			SendMessage(plugin.hwndParent, WM_WA_IPC, (WPARAM)url, IPC_MBOPEN);
		}
	}
}

///////////////////////////////////////////

void CWinampNormal::ChooseCursor(POINT point)
{
	if (!usecursors)
	{
		SetCursor(LoadCursor(NULL, IDC_ARROW));
		return;
	}

	HCURSOR hCursor = (HCURSOR)-1;

	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// resizing rectangle
	if (m_wafResize.PtInFunction(point, &rcWnd))
	{
		hCursor = m_hCursorResize;
	}

	// slider rectangle
	if (m_wafSlider.PtInHitRegion(point, &rcWnd))
	{
		hCursor = m_hCursorSizeV;
	}

	if (m_wafResize.IsClicked())	hCursor = m_hCursorResize;
	if (m_wafSlider.IsClicked())	hCursor = m_hCursorSizeV;
	if (m_wafClose.IsClicked())		hCursor = m_hCursorClose;
	if (m_wafDrag.IsClicked())		hCursor = m_hCursorMove;
	if (m_wafWinshade.IsClicked())	hCursor = m_hCursorArrow;

	if (hCursor != (HCURSOR)-1)
	{
		SetCursor(hCursor);
	}
	else
	{
		CWinampUI::ChooseCursor(point);
	}
}

void CWinampNormal::DrawInterface(HDC hDC /*=NULL*/)
{
	HDC hdcDraw = hDC;
	HDC memDC;
	HBITMAP hOldBmp;
	RECT rcTemp;
	int x, y, repeatSize;
	int nAlbumDrawn = 0;

	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	HDC hdcOffscreen;
	HBITMAP tempBitmap, oldBitmap;

	// create our own DC if none is passed in
	if (hDC == NULL)
	{
		hdcDraw = GetDC(m_hWnd);
	}

	// create offscreen memory DC to prevent flickering
	hdcOffscreen = CreateCompatibleDC(hdcDraw);
	tempBitmap = CreateCompatibleBitmap(hdcDraw, rcWnd.right, rcWnd.bottom);
	oldBitmap = (HBITMAP)SelectObject(hdcOffscreen, tempBitmap);

	// bitmap dc
	memDC = CreateCompatibleDC(hdcDraw);
	hOldBmp = (HBITMAP)SelectObject(memDC, m_hBmp);

	// are we in focus or dim title
	y = ((GetFocus() == m_hWnd) || !hilite) ? 0 : 21;

	// draw upper-left corner
	BitBlt(hdcOffscreen, 0, 0, TITLEBAR_LEFT_CORNER.cx, TITLEBAR_LEFT_CORNER.cy, memDC, 0, y, SRCCOPY);

	// draw upper-right corner
	BitBlt(hdcOffscreen, rcWnd.right - TITLEBAR_RIGHT_CORNER.cx, 0, TITLEBAR_RIGHT_CORNER.cx, TITLEBAR_RIGHT_CORNER.cy, memDC, 153, y, SRCCOPY);

	// draw lower-left corner
	BitBlt(hdcOffscreen, 0, rcWnd.bottom - BOTTOM_LEFT.cy, BOTTOM_LEFT.cx, BOTTOM_LEFT.cy, memDC, 0, 72, SRCCOPY);

	// draw lower-right corner
	BitBlt(hdcOffscreen, rcWnd.right - BOTTOM_RIGHT.cx, rcWnd.bottom - BOTTOM_RIGHT.cy, BOTTOM_RIGHT.cx, BOTTOM_RIGHT.cy, memDC, 126, 72, SRCCOPY);

	// if using Playlist Editor's bitmap
	if (m_pWinampAL->m_bUsePLBitmap && al_rmpltitle)
	{
		// draw title repeats
		x = TITLEBAR_LEFT_CORNER.cx;
		repeatSize = rcWnd.right - TITLEBAR_RIGHT_CORNER.cx - x;
		while (repeatSize)
		{
			int width = min(TITLEBAR_REPEAT.cx, repeatSize);
			
			BitBlt(hdcOffscreen, x, 0, width, TITLEBAR_REPEAT.cy, memDC, 127, y, SRCCOPY);

			x += width;
			repeatSize -= width;
		}
	}
	else
	{
		// detect fullsize title bar
		BOOL bFullSizeTitle = TRUE;
		if (GetPixel(memDC, 102, 0) != GetPixel(memDC, 96, 0))
		{
			bFullSizeTitle = FALSE;		// short title?
			for (int p=0; p<20; p++)
			{
				if (GetPixel(memDC, 102, 0) != GetPixel(memDC, 102, p))
				{
					bFullSizeTitle = TRUE;
					break;
				}
			}
		}

		SIZE title = bFullSizeTitle ? TITLEBAR_TITLE_PL : TITLEBAR_TITLE;

		// draw title
		x = (rcWnd.right - title.cx) / 2;
		BitBlt(hdcOffscreen, x, 0, title.cx, title.cy, memDC, 26, y, SRCCOPY);

		// draw title repeats (left)
		repeatSize = x - TITLEBAR_LEFT_CORNER.cx;
		x = TITLEBAR_LEFT_CORNER.cx;
		while (repeatSize)
		{
			int width = min(TITLEBAR_REPEAT.cx, repeatSize);
			
			BitBlt(hdcOffscreen, x, 0, width, TITLEBAR_REPEAT.cy, memDC, 127, y, SRCCOPY);

			x += width;
			repeatSize -= width;
		}

		// draw title repeats (right)
		x += title.cx;
		repeatSize = rcWnd.right - TITLEBAR_RIGHT_CORNER.cx - x;
		while (repeatSize)
		{
			int width = min(TITLEBAR_REPEAT.cx, repeatSize);

			BitBlt(hdcOffscreen, x, 0, width, TITLEBAR_REPEAT.cy, memDC, 127, y, SRCCOPY);

			x += width;
			repeatSize -= width;
		}
	}

	// draw left side
	y = TITLEBAR_LEFT_CORNER.cy;
	repeatSize = rcWnd.bottom - TITLEBAR_LEFT_CORNER.cy - BOTTOM_LEFT.cy;
	while (repeatSize)
	{
		int height = min(LEFT_REPEAT.cy, repeatSize);

		BitBlt(hdcOffscreen, 0, y, LEFT_REPEAT.cx, height, memDC, 0, 42, SRCCOPY);

		y += height;
		repeatSize -= height;
	}

	// draw right side
	x = rcWnd.right - RIGHT_REPEAT.cx;
	y = TITLEBAR_RIGHT_CORNER.cy;
	repeatSize = rcWnd.bottom - TITLEBAR_RIGHT_CORNER.cy - BOTTOM_RIGHT.cy;
	while (repeatSize)
	{
		int height = min(RIGHT_REPEAT.cy, repeatSize);

		BitBlt(hdcOffscreen, x, y, RIGHT_REPEAT.cx, height, memDC, 26, 42, SRCCOPY);

		y += height;
		repeatSize -= height;
	}

	// overwrite the "list option" button
	y = rcWnd.bottom - BOTTOM_REPEAT.cy;
	if (m_pWinampAL->m_bUsePLBitmap)
	{
		x = rcWnd.right - 50;
		repeatSize = 30;
		while (repeatSize)
		{
			int width = min(BOTTOM_REPEAT.cx, repeatSize);

			BitBlt(hdcOffscreen, x, y, width, BOTTOM_REPEAT.cy, memDC, 179, 0, SRCCOPY);

			x += width;
			repeatSize -= width;
		}
	}

	// draw bottom repeat
	if (m_pWinampAL->m_bUsePLBitmap)
	{
		repeatSize = rcWnd.right - 11 - BOTTOM_RIGHT.cx;
		x = 11;
	}
	else
	{
		repeatSize = rcWnd.right - BOTTOM_LEFT.cx - BOTTOM_RIGHT.cx;
		x = BOTTOM_LEFT.cx;
	}
	while (repeatSize)
	{
		int width = min(BOTTOM_REPEAT.cx, repeatSize);

		BitBlt(hdcOffscreen, x, y, width, BOTTOM_REPEAT.cy, memDC, 179, 0, SRCCOPY);

		x += width;
		repeatSize -= width;
	}

	// close button
	if (m_wafClose.IsActive())
	{
		x = rcWnd.right - 2 - CLICKED_CLOSE.cx;
		y = 3;
		BitBlt(hdcOffscreen, x, y, CLICKED_CLOSE.cx, CLICKED_CLOSE.cy, memDC, 52, 42, SRCCOPY);
	}

	// winshade button
	if (m_wafWinshade.IsActive())
	{
		x = rcWnd.right - 12 - CLICKED_WINSHADE.cx;
		if (m_pWinampAL->m_bUsePLBitmap) x += 1;
		y = 3;
		BitBlt(hdcOffscreen, x, y, CLICKED_WINSHADE.cx, CLICKED_WINSHADE.cy, memDC, 62, 42, SRCCOPY);
	}

	// fill the list area black
	rcTemp.left = 12;
	rcTemp.top = 20;
	rcTemp.right = rcWnd.right - 24 + 4;
	rcTemp.bottom = rcWnd.bottom - 38;
	HBRUSH hNormalBG = CreateSolidBrush(color_normalbg);
	HBRUSH hSelectBG = CreateSolidBrush(color_selectedbg);
	FillRect(hdcOffscreen, &rcTemp, hNormalBG);
	InflateRect(&rcTemp, 0, -2);
	rcTemp.bottom += 2;
	rcTemp.right -= 4;

#ifdef _DEBUG
	if (m_pAlbumList->GetSize())
	{
		char str[256];
		int nCount = 1;
		for (int i=0; i<m_pAlbumList->GetSize(); i++)
		{
			wsprintf(str, "\t%ld. %s\t(%ld)\n", i+1, m_pAlbumList->GetAlbum(i)->name, nCount);
			nCount += m_pAlbumList->GetAlbum(i)->nCount;
			OutputDebugString(str);
		}
	}
#endif

	// draw album list first (the TextOut doesn't clip!)
	if (m_pAlbumList->GetSize())
	{
		int i;
		SetMapMode(hdcOffscreen, MM_TEXT);

		HFONT hOldFont = (HFONT)SelectObject(hdcOffscreen, m_hFont);

		// get text height
		TEXTMETRIC tm;
		GetTextMetrics(hdcOffscreen, &tm);
		m_nTextHeight = tm.tmHeight;

		SetTextColor(hdcOffscreen, color_normal);
		SetBkColor(hdcOffscreen, color_normalbg);

		nAlbumDrawn = 0;

		int nMaxAlbumDrawn = (rcTemp.bottom - rcTemp.top) / m_nTextHeight;
		if ((m_pAlbumList->GetSize() - nMaxAlbumDrawn) < m_wafSlider.GetValue())
		{
			m_wafSlider.SetValue(max(0, m_pAlbumList->GetSize() - nMaxAlbumDrawn));
		}
		
		for (i=m_wafSlider.GetValue(); i<m_pAlbumList->GetSize(); i++)
		{
			char szAlbum[128];
			char szTime[64];
			char szTimeFormat[64];
			COLORREF colorRef, colorRef1;

			if ((rcTemp.top + m_nTextHeight) > rcTemp.bottom) break;
			
			if (shownumsinpl)
			{
				char spacestr[4] = " ";
				char numberstr[10] = "";
				if ((i+1) >= 10) spacestr[0] = 0;
				if (m_pAlbumList->GetSize() < 10) spacestr[0] = 0; 
				wsprintf(szAlbum, "%s%ld. %s", spacestr, i+1, m_pAlbumList->GetAlbum(i)->name);
			}
			else
			{
				lstrcpyn(szAlbum, m_pAlbumList->GetAlbum(i)->name, 128);
			}

			FixTitles(szAlbum);

			if (al_timeformat == 0)			// off
			{
				lstrcpy(szTime, "");
				lstrcpy(szTimeFormat, "");
			}
			else if (al_timeformat == 1)	// 8:88:88
			{
				int hour = m_pAlbumList->GetAlbum(i)->nTotalTime / 3600;
				int min = (m_pAlbumList->GetAlbum(i)->nTotalTime - hour * 3600) / 60;
				wsprintf(szTime, "%ld:%02ld:%02ld", hour, min, m_pAlbumList->GetAlbum(i)->nTotalTime % 60);
				lstrcpy(szTimeFormat, "8:88:88");
			}
			else if (al_timeformat == 2)	// 888:88
			{
				wsprintf(szTime, "%ld:%02ld", m_pAlbumList->GetAlbum(i)->nTotalTime / 60, m_pAlbumList->GetAlbum(i)->nTotalTime % 60);
				lstrcpy(szTimeFormat, "888:88");
			}

			if (al_shownum)	// (888)
			{
				char szTemp[10];
				wsprintf(szTemp, " (%02ld)", m_pAlbumList->GetAlbum(i)->nCount);
				lstrcat(szTime, szTemp);
				lstrcat(szTimeFormat, " (888)");
			}

			if (al_showyear)	// 8888
			{
				char szTemp[10];
				wsprintf(szTemp, " - %04ld", m_pAlbumList->GetAlbum(i)->nYear);
				lstrcat(szTime, szTemp);
				lstrcat(szTimeFormat, " - 8888");
			}

			if (IsSelection(i))
			{
				RECT rcTemp2 = rcTemp;
				rcTemp2.bottom = rcTemp2.top + m_nTextHeight;
				rcTemp2.right += 4;
				colorRef = SetBkColor(hdcOffscreen, color_selectedbg);
				FillRect(hdcOffscreen, &rcTemp2, hSelectBG);
			}

			if ((lstrcmp(m_pAlbumList->GetAlbum(i)->m3u_path, al_index) == 0) ||
				(lstrcmp(m_pAlbumList->GetAlbum(i)->path, al_index) == 0))
			{
				colorRef1 = SetTextColor(hdcOffscreen, color_current);
			}
			else if (m_pAlbumList->GetAlbum(i)->dwFlags & AI_CDROM)
			{
				colorRef1 = SetTextColor(hdcOffscreen, color_cdrom);
			}

			// depends on which language, we have to use Unicode to display them
			SIZE size;
			RECT rcTemp2 = rcTemp;
			switch (al_language)
			{
			case IDC_LANGUAGE_ENU:
				GetTextExtentPoint32(hdcOffscreen, szTimeFormat, lstrlen(szTimeFormat), &size);
				rcTemp2.right -= size.cx + 2;
				rcTemp2.bottom -= 1;
				DrawText(hdcOffscreen, szAlbum, -1, &rcTemp2, DT_NOPREFIX|DT_END_ELLIPSIS|DT_SINGLELINE);
				DrawText(hdcOffscreen, szTime, -1, &rcTemp, DT_NOPREFIX|DT_END_ELLIPSIS|DT_SINGLELINE|DT_RIGHT);
				break;
			
			case IDC_LANGUAGE_CHT:
				TextOutUnicode(hdcOffscreen, &rcTemp, 950, szAlbum, szTime, szTimeFormat);
				break;

			case IDC_LANGUAGE_CHS:
				TextOutUnicode(hdcOffscreen, &rcTemp, 936, szAlbum, szTime, szTimeFormat);
				break;

			case IDC_LANGUAGE_JPN:
				TextOutUnicode(hdcOffscreen, &rcTemp, 932, szAlbum, szTime, szTimeFormat);
				break;

			case IDC_LANGUAGE_KOR:
				TextOutUnicode(hdcOffscreen, &rcTemp, 949, szAlbum, szTime, szTimeFormat);
				break;
			}

 			rcTemp.top += m_nTextHeight;

			if (IsSelection(i))
			{
				SetBkColor(hdcOffscreen, colorRef);
			}

			if ((lstrcmp(m_pAlbumList->GetAlbum(i)->m3u_path, al_index) == 0) ||
				(lstrcmp(m_pAlbumList->GetAlbum(i)->path, al_index) == 0))
			{
				SetTextColor(hdcOffscreen, colorRef1);
			}
			else if (m_pAlbumList->GetAlbum(i)->dwFlags & AI_CDROM)
			{
				SetTextColor(hdcOffscreen, colorRef1);
			}

			nAlbumDrawn++;
		}
		SelectObject(hdcOffscreen, hOldFont);
	}
	// draw some text asking the user to
	// MP3 file paths
	else
	{
	}
	DeleteObject(hNormalBG);
	DeleteObject(hSelectBG);

	// draw slider
	int nSteps = m_pAlbumList->GetSize() - nAlbumDrawn;
	if (nSteps < 0) MessageBox(NULL, "test", "test", MB_OK);
	m_wafSlider.SetSteps(nSteps);
	x = rcWnd.right - 15;
	y = 20;

	int nTemp = rcWnd.bottom - 38 -20 - SLIDER_UP.cy;
	if (m_wafSlider.GetSteps() != 0)
	{
		y += (m_wafSlider.GetValue() * nTemp) / m_wafSlider.GetSteps();
	}

	if (m_wafSlider.IsClicked())
	{
		BitBlt(hdcOffscreen, x, y, SLIDER_UP.cx, SLIDER_UP.cy, memDC, 61, 53, SRCCOPY);
	}
	else
	{
		BitBlt(hdcOffscreen, x, y, SLIDER_UP.cx, SLIDER_UP.cy, memDC, 52, 53, SRCCOPY);
	}

	// draw total time
	rcTemp.left = rcWnd.right - 144;
	rcTemp.top = rcWnd.bottom - 29;
	rcTemp.right = rcWnd.right - 54;
	rcTemp.bottom = rcWnd.bottom - 21;
	HBRUSH hNormalBGT = CreateSolidBrush(color_normalbg);
//	FillRect(hdcOffscreen, &rcTemp, hNormalBGT);
	DeleteObject(hNormalBGT);
	rcTemp.left++;
	rcTemp.top++;

	// generate the time strings
	char szCurrenTime[16] = "0:00", szTotalTime[16] = "0:00", szTimeString[32];
	int nCurrentTime = 0, nTotalTime = m_pAlbumList->GetTotalTime();
	if (m_nCurrentSelection != -1)
	{
		LPALBUMINFO pInfo = m_pAlbumList->GetAlbum(m_nCurrentSelection);
		if (pInfo) nCurrentTime = pInfo->nTotalTime;
	}
	if (nTotalTime >= 3600)
	{
		int hour = nTotalTime / 3600;
		int min = (nTotalTime - hour * 3600) / 60;
		wsprintf(szTotalTime, "%ld:%02ld:%02ld", hour, min, nTotalTime % 60);
	}
	else
	{
		wsprintf(szTotalTime, "%ld:%02ld", nTotalTime / 60, nTotalTime % 60);
	}
	if ((nCurrentTime >= 3600) && (al_timeformat != 2))
	{
		int hour = nCurrentTime / 3600;
		int min = (nCurrentTime - hour * 3600) / 60;
		wsprintf(szCurrenTime, "%ld:%02ld:%02ld", hour, min, nCurrentTime % 60);
	}
	else
	{
		wsprintf(szCurrenTime, "%ld:%02ld", nCurrentTime / 60, nCurrentTime % 60);
	}
	wsprintf(szTimeString, "%s/%s", szCurrenTime, szTotalTime);

	DrawBitmapFont(hdcOffscreen, rcTemp, szTimeString);

	if (m_pWinampAL->m_nCurrentTime != -1)
	{
		char szTimeString[3];

		int second = (m_pWinampAL->m_nCurrentTime / 1000) % 60;
		wsprintf(szTimeString, "%02ld", second);

		rcTemp.top = rcWnd.bottom - 15;
		rcTemp.left = rcWnd.right - 64;
		DrawBitmapFont(hdcOffscreen, rcTemp, szTimeString);

		int minute = (m_pWinampAL->m_nCurrentTime / 1000) / 60;
		wsprintf(szTimeString, "%02ld", minute);

		rcTemp.top = rcWnd.bottom - 15;
		rcTemp.right = rcWnd.right - 67;
		DrawBitmapFont(hdcOffscreen, rcTemp, szTimeString, FALSE);
	}

	if (al_alphablend != 255)
	{
		// select background
		HDC hdcOffscreen2 = CreateCompatibleDC(hdcDraw);
		HBITMAP oldBitmap2 = (HBITMAP)SelectObject(hdcOffscreen2, m_pWinampAL->m_hBmpBackground);

		BLENDFUNCTION bf;			// AlphaBlend function parameter
		bf.BlendOp = AC_SRC_OVER;
		bf.BlendFlags = 0;
		bf.SourceConstantAlpha = 255 - al_alphablend;
		bf.AlphaFormat = 0;

		GdiAlphaBlend(hdcOffscreen, 0,0, rcWnd.right, rcWnd.bottom, hdcOffscreen2, 0, 0, rcWnd.right, rcWnd.bottom, bf); 

		// clean up (select background)
		SelectObject(hdcOffscreen2, oldBitmap2);
		DeleteDC(hdcOffscreen2);
	}

#if 0
	if (m_pAlbumList->GetAlbum(al_cindex))
	{
		BITMAP bm;
		GetObject(m_pAlbumList->GetAlbum(al_cindex)->hBitmap, sizeof(BITMAP), &bm);

		// select background
		HDC hdcOffscreen2 = CreateCompatibleDC(hdcDraw);
		HBITMAP oldBitmap2 = (HBITMAP)SelectObject(hdcOffscreen2, m_pAlbumList->GetAlbum(al_cindex)->hBitmap);

		BLENDFUNCTION bf;			// AlphaBlend function parameter
		bf.BlendOp = AC_SRC_OVER;
		bf.BlendFlags = 0;
		bf.SourceConstantAlpha = 128;
		bf.AlphaFormat = 0;

//		GdiAlphaBlend(hdcOffscreen, 0, 0, rcWnd.right, rcWnd.bottom, hdcOffscreen2, 0, 0, rcWnd.right, rcWnd.bottom, bf); 
		GdiAlphaBlend(hdcOffscreen, 11, 20, rcWnd.right - 23, rcWnd.bottom - 38, hdcOffscreen2, 0, 0, bm.bmWidth, bm.bmHeight, bf); 

		// clean up (select background)
		SelectObject(hdcOffscreen2, oldBitmap2);
		DeleteDC(hdcOffscreen2);
	}
#endif

	// copy to it back to the original dc
	BitBlt(hdcDraw, 0, 0, rcWnd.right, rcWnd.bottom, hdcOffscreen, 0, 0, SRCCOPY);

	// clean up
	SelectObject(hdcOffscreen, oldBitmap);
	SelectObject(memDC, hOldBmp);
	DeleteObject(tempBitmap);
	DeleteDC(memDC);
	DeleteDC(hdcOffscreen);

	// release the DC that we created
	if (hDC == NULL)
	{
		ReleaseDC(m_hWnd, hdcDraw);
	}
}

void CWinampNormal::SelectAlbum(int nIndex /*=-1*/)
{
	if (nIndex != -1)
	{
		CWinampUI::SelectAlbum(nIndex);
	}
	else
	{
		int size = m_SelectionSet.GetSize();
		if (size)
		{
			CWinampUI::SelectAlbum(m_SelectionSet[0]);
			for (int i=1; i<size; i++)
			{
				m_pAlbumList->EnqueueAlbum(m_pAlbumList->GetAlbum(m_SelectionSet[i]));
			}
		}
	}
}

void CWinampNormal::EnqueueAlbum(int nIndex /*=-1*/)
{
	if (nIndex != -1)
	{
		CWinampUI::EnqueueAlbum(nIndex);
	}
	else
	{
		int size = m_SelectionSet.GetSize();
		if (size)
		{
			CWinampUI::EnqueueAlbum(m_SelectionSet[0]);
			for (int i=1; i<size; i++)
			{
				m_pAlbumList->EnqueueAlbum(m_pAlbumList->GetAlbum(m_SelectionSet[i]));
			}
		}
	}
}

void CWinampNormal::UpdateTimeDisplay()
{
	RECT rcWnd, rcTemp;
	GetClientRect(m_hWnd, &rcWnd);

	HDC hdcDraw = GetDC(m_hWnd);

	if (m_pWinampAL->m_nCurrentTime != -1)
	{
		char szTimeString[3];

		int second = (m_pWinampAL->m_nCurrentTime / 1000) % 60;
		wsprintf(szTimeString, "%02ld", second);

		rcTemp.top = rcWnd.bottom - 15;
		rcTemp.left = rcWnd.right - 64;
		DrawBitmapFont(hdcDraw, rcTemp, szTimeString);

		int minute = (m_pWinampAL->m_nCurrentTime / 1000) / 60;
		wsprintf(szTimeString, "%02ld", minute);

		rcTemp.top = rcWnd.bottom - 15;
		rcTemp.right = rcWnd.right - 67;
		DrawBitmapFont(hdcDraw, rcTemp, szTimeString, FALSE);
	}

	ReleaseDC(m_hWnd, hdcDraw);
}

BOOL CWinampNormal::LButtonDown(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// resizing rectangle
	if (m_wafResize.PtInFunction(point, &rcWnd))
	{
		// BASSFIX
		const bool controlDown = (::GetKeyState(VK_CONTROL) & 0x8000) != 0;
		if (controlDown) {
			m_wafResize.Clicked(point);
			SetCapture(m_hWnd);
		}
		return TRUE;
	}

	// list rectangle
	if (m_wafAlbumList.PtInFunction(point, &rcWnd))
	{
		int nCurSel = m_wafAlbumList.GetIndex(point, &rcWnd, m_nTextHeight);

		if (nCurSel != -1)
		{
			nCurSel += m_wafSlider.GetValue();
		}
		if (nCurSel >= m_pAlbumList->GetSize())
		{
			nCurSel = -1;
		}

		if (m_nCurrentSelection != nCurSel)
		{
			if (al_showcover) ShowAlbumInMiniBrowser(nCurSel);
		}

		// multiple selection support
		if (nCurSel != -1)
		{
			if (nFlags & MK_SHIFT)
			{
				if (m_nLastSelection != -1)
				{
					SetSelectionRange(m_nLastSelection, nCurSel);
				}
			}
			else if (nFlags & MK_CONTROL)
			{
				ToggleSelection(nCurSel);
			}
			else
			{
				ClearSelection();
				ToggleSelection(nCurSel);
			}
		}
		else
		{
			ClearSelection();
		}

		DrawInterface();

		return TRUE;
	}

	// previous track
	if (m_wafPrevTrack.PtInFunction(point, &rcWnd))
	{
		if ((nFlags & MK_SHIFT) == MK_SHIFT)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON1_SHIFT, 0);
		}
		else if ((nFlags & MK_CONTROL) == MK_CONTROL)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON1_CTRL, 0);
		}
		else
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON1, 0);
		}
		return TRUE;
	}

	// play
	if (m_wafPlay.PtInFunction(point, &rcWnd))
	{
		if ((nFlags & MK_SHIFT) == MK_SHIFT)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON2_SHIFT, 0);
		}
		else if ((nFlags & MK_CONTROL) == MK_CONTROL)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON2_CTRL, 0);
		}
		else
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON2, 0);
		}
		return TRUE;
	}

	// pause
	if (m_wafPause.PtInFunction(point, &rcWnd))
	{
		if ((nFlags & MK_SHIFT) == MK_SHIFT)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON3_SHIFT, 0);
		}
		else if ((nFlags & MK_CONTROL) == MK_CONTROL)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON3_CTRL, 0);
		}
		else
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON3, 0);
		}
		return TRUE;
	}

	// stop
	if (m_wafStop.PtInFunction(point, &rcWnd))
	{
		if ((nFlags & MK_SHIFT) == MK_SHIFT)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON4_SHIFT, 0);
		}
		else if ((nFlags & MK_CONTROL) == MK_CONTROL)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON4_CTRL, 0);
		}
		else
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON4, 0);
		}
		return TRUE;
	}

	// next track
	if (m_wafNextTrack.PtInFunction(point, &rcWnd))
	{
		if ((nFlags & MK_SHIFT) == MK_SHIFT)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON5_SHIFT, 0);
		}
		else if ((nFlags & MK_CONTROL) == MK_CONTROL)
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON5_CTRL, 0);
		}
		else
		{
			SendMessage(m_hWinamp, WM_COMMAND, WINAMP_BUTTON5, 0);
		}
		return TRUE;
	}

	// load
	if (m_wafLoadFile.PtInFunction(point, &rcWnd))
	{
		SendMessage(m_hWinamp, WM_COMMAND, WINAMP_FILE_PLAY, 0);
		return TRUE;
	}

	// scroll down
	if (m_wafScrollDown.PtInFunction(point, &rcWnd))
	{
		int value = m_wafSlider.GetValue();
		value += 4;
		if (value > m_wafSlider.GetSteps()) value = m_wafSlider.GetSteps();

		m_wafSlider.SetValue(value);
		DrawInterface();
		return TRUE;
	}

	// scroll up
	if (m_wafScrollUp.PtInFunction(point, &rcWnd))
	{
		int value = m_wafSlider.GetValue();
		value -= 4;
		if (value < 0) value = 0;

		m_wafSlider.SetValue(value);
		DrawInterface();
		return TRUE;
	}

	// slider knob
	if (m_wafSlider.PtInFunction(point, &rcWnd))
	{
		m_wafSlider.Clicked(point);
		SetCapture(m_hWnd);
		DrawInterface();

		return TRUE;
	}

	// slider rectangle
	if (m_wafSlider.PtInHitRegion(point, &rcWnd))
	{
		int curpos = point.y - 20 - SLIDER_UP.cy / 2;
		int fullrange = rcWnd.bottom - 20 - 38 - SLIDER_UP.cy;
		if (curpos > fullrange) curpos = fullrange;
		if (curpos < 0) curpos = 0;
		int value = (curpos * m_wafSlider.GetSteps()) / fullrange;

		if (value != m_wafSlider.GetValue())
		{
			m_wafSlider.SetValue(value);
		}

		m_wafSlider.Clicked(point);
		SetCapture(m_hWnd);
		DrawInterface();

		return TRUE;
	}

	return CWinampUI::LButtonDown(nFlags, point);
}

BOOL CWinampNormal::LButtonUp(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	if (m_wafResize.IsClicked())
	{
		m_wafResize.Release();
		ReleaseCapture();

		return TRUE;
	}

	if (m_wafSlider.IsClicked())
	{
		m_wafSlider.Release();
		ReleaseCapture();
		DrawInterface();

		return TRUE;
	}

	return CWinampUI::LButtonUp(nFlags, point);
}

BOOL CWinampNormal::LButtonDblClk(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// list rectangle
	if (m_wafAlbumList.PtInFunction(point, &rcWnd))
	{
		LPALBUMINFO album = m_pAlbumList->GetAlbum(m_nCurrentSelection);

		if (album == NULL) return FALSE;

		if (((GetKeyState(VK_SHIFT) & 0x80000000) == 0x80000000) ^ 
			(al_enqueue == TRUE))
		{
			m_pAlbumList->EnqueueAlbum(album);
		}
		else
		{
			m_pAlbumList->PlayAlbum(album);
		}
		DrawInterface();
		return TRUE;
	}

	return CWinampUI::LButtonDblClk(nFlags, point);
}

BOOL CWinampNormal::RButtonUp(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// list rectangle
	if (m_wafAlbumList.PtInFunction(point, &rcWnd))
	{
		int nCurSel = m_wafAlbumList.GetIndex(point, &rcWnd, m_nTextHeight);

		if (nCurSel != -1)
		{
			nCurSel += m_wafSlider.GetValue();
		}
		if (nCurSel >= m_pAlbumList->GetSize())
		{
			nCurSel = -1;
		}

		// multiple selection support
		if (nCurSel != -1)
		{
			if (nFlags & MK_CONTROL)
			{
				ToggleSelection(nCurSel);
			}
			else if (!IsSelection(nCurSel))
			{
				ClearSelection();
				ToggleSelection(nCurSel);
			}
		}
		else
		{
			ClearSelection();
		}

		DrawInterface();

		return TRUE;
	}

	return CWinampUI::RButtonUp(nFlags, point);
}

BOOL CWinampNormal::MouseMove(UINT nFlags, POINT point)
{
	ChooseCursor(point);

	int width, height;
	RECT rcWnd, rcWndClient;
	GetWindowRect(m_hWnd, &rcWnd);
	GetClientRect(m_hWnd, &rcWndClient);

	//Fixed Resizing Code
	if (((nFlags & MK_LBUTTON) == MK_LBUTTON) && m_wafResize.IsClicked())
	{
		BOOL bSizeChanged = FALSE;

		width = rcWndClient.right;
		height = rcWndClient.bottom;

		//Resize in X direction outwards
		if (point.x >= (m_wafResize.m_ptDown.x + 1))
		{
			int inc = (point.x - (m_wafResize.m_ptDown.x + 1)) / RESIZE_WIDTH + 1;

			rcWndClient.right += inc * RESIZE_WIDTH;
			if(rcWndClient.right >= MIN_WIDTH)
			{
				width = rcWndClient.right;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.x += inc * RESIZE_WIDTH;
			}
		}
		//Resize in X direction inwards
		else if (point.x <= (m_wafResize.m_ptDown.x - RESIZE_WIDTH))
		{
			int inc = (point.x - (m_wafResize.m_ptDown.x - RESIZE_WIDTH)) / RESIZE_WIDTH - 1;

			rcWndClient.right += inc * RESIZE_WIDTH;
			if(rcWndClient.right >= MIN_WIDTH)
			{
				width = rcWndClient.right;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.x += inc * RESIZE_WIDTH;
			}
			else
			{
				width = MIN_WIDTH;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.x += MIN_WIDTH - (rcWnd.right - rcWnd.left);
			}
		}
		//Resize in Y direction outwards
		if (point.y >= (m_wafResize.m_ptDown.y + 1))
		{
			int inc = (point.y - (m_wafResize.m_ptDown.y + 1)) / RESIZE_HEIGHT + 1;

			rcWndClient.bottom += inc * RESIZE_HEIGHT;
			if (rcWndClient.bottom >= MIN_HEIGHT)
			{
				height = rcWndClient.bottom;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.y += inc * RESIZE_HEIGHT;
			}
		}
		//Resize in Y direction inwards
		else if (point.y <= (m_wafResize.m_ptDown.y - RESIZE_HEIGHT))
		{
			int inc = (point.y - (m_wafResize.m_ptDown.y - RESIZE_HEIGHT)) / RESIZE_HEIGHT - 1;

			rcWndClient.bottom += inc * RESIZE_HEIGHT;
			if (rcWndClient.bottom >= MIN_HEIGHT)
			{
				height = rcWndClient.bottom;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.y += inc * RESIZE_HEIGHT;
			}
			else
			{
				height = MIN_HEIGHT;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.y += MIN_HEIGHT - (rcWnd.bottom - rcWnd.top);
			}
		}
		if (bSizeChanged)
		{
			SetWindowPos(m_hWnd, NULL, 0, 0, width, height, SWP_NOZORDER|SWP_NOMOVE);
		}

		return TRUE;
	}

	// slider rectangle
	if (m_wafSlider.IsClicked())
	{
		int curpos = point.y - 19;
		int value = m_wafSlider.GetValue();
		int fullrange = rcWndClient.bottom - 19 - 38 - SLIDER_UP.cy;
		if (curpos > fullrange) curpos = fullrange;
		if (curpos < 0) curpos = 0;

		value = (curpos * m_wafSlider.GetSteps()) / fullrange;

		if (value != m_wafSlider.GetValue())
		{
			m_wafSlider.SetValue(value);
			DrawInterface();
		}

		return TRUE;
	}

	//Manual Sort via Mouse (T-Matsuo)
	if (((nFlags & MK_LBUTTON) == MK_LBUTTON) && m_wafAlbumList.PtInFunction(point, &rcWndClient))
	{
		// cur up/down
		int nCurSel = m_wafAlbumList.GetIndex(point, &rcWndClient, m_nTextHeight);
		if ((nCurSel != -1))
		{
			if (m_wafSlider.GetValue() + nCurSel < m_nCurrentSelection)
			{
				MoveUp();
			}
			else if (m_wafSlider.GetValue() + nCurSel > m_nCurrentSelection)
			{
				MoveDown();
			}
		}
		return TRUE;
	}

	return CWinampUI::MouseMove(nFlags, point);
}

void CWinampNormal::MouseWheel(WORD fwKeys, short zDelta, POINT point)
{
	m_zWheelDelta += zDelta;

	if (abs(m_zWheelDelta) >= WHEEL_DELTA)
	{
		int nSteps = min(8,max(0, m_pAlbumList->GetSize()-m_wafSlider.GetSteps()));

		if (m_zWheelDelta < 0)
		{
			int value = m_wafSlider.GetValue();
			value += nSteps;
			if (value > m_wafSlider.GetSteps()) value = m_wafSlider.GetSteps();

			m_wafSlider.SetValue(value);
			DrawInterface();
		}
		else if (m_zWheelDelta > 0)
		{
			int value = m_wafSlider.GetValue();
			value -= nSteps;
			if (value < 0) value = 0;

			m_wafSlider.SetValue(value);
			DrawInterface();
		}
		m_zWheelDelta = m_zWheelDelta % WHEEL_DELTA;
	}
}

BOOL CWinampNormal::ContextMenu(HWND hWnd, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);
	POINT ptClient = point;
	ScreenToClient(hWnd, &ptClient);

	// list rectangle
	if (m_wafAlbumList.PtInFunction(ptClient, &rcWnd))
	{
		if (m_nCurrentSelection != -1)
		{
			HMENU hMenu = CreatePopupMenu();
			AppendMenu(hMenu, MF_STRING, IDC_PLAY_ALBUM, ALSTRING("&Play Album", al_enqueue ? "\tShift+Enter" : "\tEnter"));
			AppendMenu(hMenu, MF_STRING, IDC_ENQUEUE_ALBUM, ALSTRING("&En-queue Album", al_enqueue ? "\tEnter" : "\tShift+Enter"));
			AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hMenu, MF_STRING, IDC_PLAY_ALL_ALBUM, ALSTRING("Play &All Albums"));
			AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hMenu, MF_STRING, IDC_ALBUM_INFO, ALSTRING("Album &Info", "\tF2"));
//			AppendMenu(hMenu, MF_STRING, IDC_RENAME_ALBUM, ALSTRING("Re&name Album", "\tF2"));
			AppendMenu(hMenu, MF_STRING, IDC_SHOWCOVERINBROWSER, ALSTRING("&Show Album Cover"));
			AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hMenu, MF_STRING, IDC_REFRESH, ALSTRING("&Refresh"));
			AppendMenu(hMenu, MF_SEPARATOR, 0, NULL);
			AppendMenu(hMenu, MF_STRING, IDC_WRITE_PLAYLIST, ALSTRING("&Write Playlist", "\tCtrl+S"));

			SetMenuDefaultItem(hMenu, al_enqueue ? IDC_ENQUEUE_ALBUM : IDC_PLAY_ALBUM, FALSE);

			DWORD dwFlags = TPM_LEFTALIGN|TPM_RETURNCMD|TPM_NONOTIFY|TPM_RIGHTBUTTON|TPM_LEFTBUTTON;
			UINT nRet = TrackPopupMenu(hMenu, dwFlags, point.x, point.y, 0, m_hWnd, NULL);
			DestroyMenu(hMenu);

			switch (nRet)
			{
			case IDC_ENQUEUE_ALBUM:
				EnqueueAlbum();
				break;

			case IDC_PLAY_ALBUM:
				SelectAlbum();
				break;

			case IDC_PLAY_ALL_ALBUM:
				PlayAllAlbums();
				break;

			case IDC_SHOWCOVERINBROWSER:
				ShowAlbumInMiniBrowser(m_nCurrentSelection);
				break;

			case IDC_ALBUM_INFO:
				if (m_nCurrentSelection != -1)
				{
					DialogBox(plugin.hDllInstance, MAKEINTRESOURCE(IDD_ALBUMINFO), m_hWnd, AlbumInfoProc);
				}
				break;

			case IDC_RENAME_ALBUM:
				if (m_nCurrentSelection != -1)
				{
					DialogBox(plugin.hDllInstance, MAKEINTRESOURCE(IDD_RENAMEALBUM), m_hWnd, RenameAlbumProc);
				}
				break;

			case IDC_REFRESH:
				RefreshAlbum();
				break;

			case IDC_WRITE_PLAYLIST:
				m_pAlbumList->WritePlaylist(m_hWnd, m_nCurrentSelection);
				DrawInterface();
				break;
			}
			return TRUE;
		}
	}

	return CWinampUI::ContextMenu(hWnd, point);
}

void CWinampNormal::RefreshAlbum()
{
	int size = m_SelectionSet.GetSize();
	if (size)
	{
		for (int i=0; i<size; i++)
		{
			m_pAlbumList->RefreshAlbum(m_SelectionSet[i]);
		}
	}
}

void CWinampNormal::NextAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	CWinampUI::NextAlbum();

	int min = m_wafSlider.GetValue();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	if (m_nCurrentSelection < min)
	{
		m_nCurrentSelection = min;
	}
	else if (m_nCurrentSelection > max + 1)
	{
		m_nCurrentSelection = min;
	}
	else if (m_nCurrentSelection > max)
	{
		m_wafSlider.SetValue(min+1);
	}

	SetSelection(m_nCurrentSelection);
	DrawInterface();
}

void CWinampNormal::PrevAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	CWinampUI::PrevAlbum();

	int min = m_wafSlider.GetValue();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	if (m_nCurrentSelection > max)
	{
		m_nCurrentSelection = min;
	}
	if (m_nCurrentSelection < min - 1)
	{
		m_nCurrentSelection = min;
	}
	else if (m_nCurrentSelection < min)
	{
		m_wafSlider.SetValue(min-1);
	}

	SetSelection(m_nCurrentSelection);
	DrawInterface();
}

void CWinampNormal::EndAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	m_wafSlider.SetValue(m_wafSlider.GetSteps());
	DrawInterface();
}

void CWinampNormal::HomeAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	m_wafSlider.SetValue(0);
	DrawInterface();
}

void CWinampNormal::PageUpAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	int min = m_wafSlider.GetValue();
	int range = m_pAlbumList->GetSize() - m_wafSlider.GetSteps();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	if ((min - range) < 0)
	{
		m_wafSlider.SetValue(0);
	}
	else
	{
		m_wafSlider.SetValue(min-range);
	}
	DrawInterface();
}

void CWinampNormal::PageDownAlbum()
{
	if (m_pAlbumList->GetSize() == 0) return;

	int min = m_wafSlider.GetValue();
	int range = m_pAlbumList->GetSize() - m_wafSlider.GetSteps();
	int max = m_pAlbumList->GetSize() - 1;

	if ((min + range) >= max)
	{
		m_wafSlider.SetValue(max - range + 1);
	}
	else if ((min + range*2) >= max)
	{
		m_wafSlider.SetValue(max - range + 1);
	}
	else
	{
		m_wafSlider.SetValue(min+range);
	}
	DrawInterface();
}

void CWinampNormal::PlayNextAlbum()
{
	CWinampUI::PlayNextAlbum();

	if (m_pAlbumList->GetSize() == 0) return;
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	if (cindex == -1) return;

	int min = m_wafSlider.GetValue();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	while (cindex < min)
	{
		PageUpAlbum();
		min = m_wafSlider.GetValue();
	}
	while (cindex > max)
	{
		PageDownAlbum();
		max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;
	}
}

void CWinampNormal::PlayNextArtist()
{
	CWinampUI::PlayNextArtist();

	if (m_pAlbumList->GetSize() == 0) return;
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	if (cindex == -1) return;

	int min = m_wafSlider.GetValue();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	while (cindex < min)
	{
		PageUpAlbum();
		min = m_wafSlider.GetValue();
	}
	while (cindex > max)
	{
		PageDownAlbum();
		max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;
	}
}

void CWinampNormal::PlayPrevAlbum()
{
	CWinampUI::PlayPrevAlbum();

	if (m_pAlbumList->GetSize() == 0) return;
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	if (cindex == -1) return;

	int min = m_wafSlider.GetValue();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	while (cindex < min)
	{
		PageUpAlbum();
		min = m_wafSlider.GetValue();
	}
	while (cindex > max)
	{
		PageDownAlbum();
		max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;
	}
}

void CWinampNormal::PlayPrevArtist()
{
	CWinampUI::PlayPrevArtist();

	if (m_pAlbumList->GetSize() == 0) return;
	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	if (cindex == -1) return;

	int min = m_wafSlider.GetValue();
	int max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;

	while (cindex < min)
	{
		PageUpAlbum();
		min = m_wafSlider.GetValue();
	}
	while (cindex > max)
	{
		PageDownAlbum();
		max = m_wafSlider.GetValue() + m_pAlbumList->GetSize() - m_wafSlider.GetSteps() - 1;
	}
}

void CWinampNormal::MoveUp()
{
	if (m_nCurrentSelection == -1) return;
	if (m_pAlbumList->GetSize() == 0) return;
	if (0 == m_nCurrentSelection) return;

	int size = m_SelectionSet.GetSize();
	for (int i=0; i<size; i++)
	{
		int nSel = m_SelectionSet[i];
		m_pAlbumList->SwapAlbum(nSel, nSel-1);
		m_SelectionSet.SetAt(i, nSel-1);
	}
	m_nCurrentSelection--;
	DrawInterface();
}

void CWinampNormal::MoveDown()
{
	if (m_nCurrentSelection == -1) return;
	if (m_pAlbumList->GetSize() == 0) return;

	int size = m_SelectionSet.GetSize();

	if (((int)m_SelectionSet[size-1] + 1) >= m_pAlbumList->GetSize()) return;

	for (int i=0; i<size; i++)
	{
		int nSel = m_SelectionSet[i];
		m_pAlbumList->SwapAlbum(nSel, nSel+1);
		m_SelectionSet.SetAt(i, nSel+1);
	}

	m_nCurrentSelection++;
	DrawInterface();
}

void CWinampNormal::MakeSelectionVisible()
{
	// make sure slider's step is set
	DrawInterface();

	int nAlbumDrawn = m_pAlbumList->GetSize() - m_wafSlider.GetSteps();

	int i=0;
	int nStart = m_wafSlider.GetValue();
	int nEnd = nStart + nAlbumDrawn;

	// is it visible?
	for (i=nStart; i<nEnd; i++)
	{
		if ((lstrcmp(m_pAlbumList->GetAlbum(i)->m3u_path, al_index) == 0) ||
			(lstrcmp(m_pAlbumList->GetAlbum(i)->path, al_index) == 0))
		{
			return;
		}
	}

	// try the previous page
	while (TRUE)
	{
		nStart -= nAlbumDrawn;
		if (nStart < 0) nStart = 0;
		nEnd = nStart + nAlbumDrawn;

		for (i=nStart; i<nEnd; i++)
		{
			if ((lstrcmp(m_pAlbumList->GetAlbum(i)->m3u_path, al_index) == 0) ||
				(lstrcmp(m_pAlbumList->GetAlbum(i)->path, al_index) == 0))
			{
				m_wafSlider.SetValue(nStart);
				DrawInterface();
				return;
			}
		}

		if (nStart == 0) break;
	}

	// try the next page
	nStart = m_wafSlider.GetValue();
	while (TRUE)
	{
		nStart += nAlbumDrawn;
		if (nStart > m_wafSlider.GetSteps()) nStart = m_wafSlider.GetSteps();
		nEnd = nStart + nAlbumDrawn;

		for (i=nStart; i<nEnd; i++)
		{
			if ((lstrcmp(m_pAlbumList->GetAlbum(i)->m3u_path, al_index) == 0) ||
				(lstrcmp(m_pAlbumList->GetAlbum(i)->path, al_index) == 0))
			{
				m_wafSlider.SetValue(nStart);
				DrawInterface();
				return;
			}
		}

		if (nStart == m_wafSlider.GetSteps()) break;
	}
}

void CWinampNormal::ToggleSelection(int nSel)
{
	int size = m_SelectionSet.GetSize();

	int i=0;
	for (i=0; i<size; i++)
	{
		// remove the selection (if already in selection set)
		if (nSel == (int)m_SelectionSet[i])
		{
			m_SelectionSet.RemoveAt(i);
			m_nLastSelection = -1;
			break;
		}
		else if (nSel < (int)m_SelectionSet[i])
		{
			m_SelectionSet.InsertAt(i, nSel);
			m_nLastSelection = nSel;
			break;
		}
	}
	if (i == size)
	{
		m_SelectionSet.Add(nSel);
		m_nLastSelection = nSel;
	}

	if (m_SelectionSet.GetSize())
	{
		m_nCurrentSelection = m_SelectionSet[0];
	}
	else
	{
		m_nCurrentSelection = -1;
	}
}

void CWinampNormal::ClearSelection()
{
	m_SelectionSet.RemoveAll();
	m_nCurrentSelection = -1;
	m_nLastSelection = -1;
}

BOOL CWinampNormal::IsSelection(int nSel)
{
	if (nSel == m_nCurrentSelection) return TRUE;

	int size = m_SelectionSet.GetSize();
	for (int i=0; i<size; i++)
	{
		if (nSel == (int)m_SelectionSet[i]) return TRUE;
	}

	return FALSE;
}

void CWinampNormal::SetSelection(int nSel)
{
	m_SelectionSet.RemoveAll();
	m_SelectionSet.Add(nSel);
	m_nCurrentSelection = nSel;
	m_nLastSelection = nSel;
}

void CWinampNormal::SetSelectionRange(int nSel1, int nSel2)
{
	int nStart = (nSel1 > nSel2) ? nSel2 : nSel1;
	int nEnd = (nSel1 > nSel2) ? nSel1 : nSel2;

	m_SelectionSet.RemoveAll();

	for (int i=nStart; i<=nEnd; i++)
		m_SelectionSet.Add(i);

	m_nCurrentSelection = nStart;
	m_nLastSelection = nSel1;
}

///////////////////////////////////////////

void CWinampWinshade::ChooseCursor(POINT point)
{
	if (!usecursors)
	{
		SetCursor(LoadCursor(NULL, IDC_ARROW));
		return;
	}

	HCURSOR hCursor = (HCURSOR)-1;

	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// resizing rectangle
	if (m_wafResize.PtInFunction(point, &rcWnd))
	{
		hCursor = m_hCursorSizeH;
	}

	if (m_wafResize.IsClicked())	hCursor = m_hCursorSizeH;
	if (m_wafClose.IsClicked())		hCursor = m_hCursorClose;
	if (m_wafDrag.IsClicked())		hCursor = m_hCursorMove;
	if (m_wafWinshade.IsClicked())	hCursor = m_hCursorArrow;

	if (hCursor != (HCURSOR)-1)
	{
		SetCursor(hCursor);
	}
	else
	{
		CWinampUI::ChooseCursor(point);
	}
}

void CWinampWinshade::DrawInterface(HDC hDC /*=NULL*/)
{
	HDC hdcDraw = hDC;
	HDC memDC;
	HBITMAP hOldBmp;
	int x, y, repeatSize;
	int nAlbumDrawn = 0;

	HDC hdcOffscreen;
	HBITMAP tempBitmap, oldBitmap;

	RECT rcWnd, rcTemp;
	GetClientRect(m_hWnd, &rcWnd);

	// create our own DC if none is passed in
	if (hDC == NULL)
	{
		hdcDraw = GetDC(m_hWnd);
	}

	// create offscreen memory DC to prevent flickering
	hdcOffscreen = CreateCompatibleDC(hdcDraw);
	tempBitmap = CreateCompatibleBitmap(hdcDraw, rcWnd.right, rcWnd.bottom);
	oldBitmap = (HBITMAP)SelectObject(hdcOffscreen, tempBitmap);

	// bitmap dc
	memDC = CreateCompatibleDC(hdcDraw);
	hOldBmp = (HBITMAP)SelectObject(memDC, m_hBmp);

	// are we in focus or dim title
	y = ((GetFocus() == m_hWnd) || !hilite) ? 0 : 15;

	// draw left side
	BitBlt(hdcOffscreen, 0, 0, WINSHADE_LEFT.cx, WINSHADE_LEFT.cy, memDC, 72, 42, SRCCOPY);

	// draw midde part
	repeatSize = rcWnd.right - WINSHADE_LEFT.cx - WINSHADE_RIGHT.cx;
	x = WINSHADE_LEFT.cx;
	while (repeatSize)
	{
		int width = min(WINSHADE_MIDDLE.cx, repeatSize);

		BitBlt(hdcOffscreen, x, 0, width, WINSHADE_MIDDLE.cy, memDC, 72, 57, SRCCOPY);

		x += width;
		repeatSize -= width;
	}

	// draw right side
	x = rcWnd.right - WINSHADE_RIGHT.cx;
	BitBlt(hdcOffscreen, x, 0, WINSHADE_RIGHT.cx, WINSHADE_RIGHT.cy, memDC, 99, 42+y, SRCCOPY);

	// close button
	if (m_wafClose.IsActive())
	{
		x = rcWnd.right - 2 - CLICKED_CLOSE.cx;
		y = 3;
		BitBlt(hdcOffscreen, x, y, CLICKED_CLOSE.cx, CLICKED_CLOSE.cy, memDC, 52, 42, SRCCOPY);
	}

	// winshade button
	if (m_wafWinshade.IsActive())
	{
		x = rcWnd.right - 12 - CLICKED_WINSHADE.cx;
		if (m_pWinampAL->m_bUsePLBitmap) x += 1;
		y = 3;
		BitBlt(hdcOffscreen, x, y, CLICKED_WINSHADE.cx, CLICKED_WINSHADE.cy, memDC, 150, 42, SRCCOPY);
	}

	// fill the list area black
	rcTemp.left = 5;
	rcTemp.top = 4;
	rcTemp.right = rcWnd.right - 30;
	rcTemp.bottom = rcWnd.bottom - 4;
	HBRUSH hNormalBGT = CreateSolidBrush(color_normalbg);
//	FillRect(hdcOffscreen, &rcTemp, hNormalBGT);
	DeleteObject(hNormalBGT);
	// draw album list
	SetTextColor(hdcOffscreen, color_normal);
	SetBkColor(hdcOffscreen, color_normalbg);

	int cindex = m_pAlbumList->GetAlbumIndex(al_index);
	if (cindex != -1)
	{
		if (m_pAlbumList->GetAlbum(cindex))
		{
			char szTemp[128] = "";
		
			int nCurrentTime = m_pAlbumList->GetAlbum(cindex)->nTotalTime;
			if (al_timeformat == 1)
			{
				int hour = nCurrentTime / 3600;
				int min = (nCurrentTime - hour * 3600) / 60;
				wsprintf(szTemp, "%ld:%02ld:%02ld", hour, min, nCurrentTime % 60);
			}
			else if (al_timeformat == 2)
			{
				wsprintf(szTemp, "%ld:%02ld", nCurrentTime / 60, nCurrentTime % 60);
			}
			else if (al_timeformat == 3)
			{
				wsprintf(szTemp, "(%ld)", m_pAlbumList->GetAlbum(cindex)->nCount);
			}

			rcTemp.right++;	// this is done to look like pledit
			DrawBitmapFont(hdcOffscreen, rcTemp, szTemp, FALSE);
			rcTemp.right--;	// this is done to look like pledit

			RECT rcTemp2 = rcTemp;
			rcTemp2.right -= lstrlen(szTemp) * 5;

			if (shownumsinpl)
			{
				wsprintf(szTemp, "%ld. %s", cindex+1, m_pAlbumList->GetAlbum(cindex)->name);
			}
			else
			{
				lstrcpyn(szTemp, m_pAlbumList->GetAlbum(cindex)->name, 128);
			}

			FixTitles(szTemp);

			if (bifont)	//Draw bitmap font option
			{
				DrawBitmapFont(hdcOffscreen, rcTemp2, szTemp, TRUE, TRUE);
			}
			else
			{
				HFONT hOldFont = (HFONT)SelectObject(hdcOffscreen, m_hFont);
				rcTemp2.top -= 2;
				rcTemp2.bottom -= 2;
				rcTemp2.bottom += 12;
				ExtTextOut(hdcOffscreen, rcTemp2.left, rcTemp2.top, ETO_CLIPPED, &rcTemp2, szTemp, strlen(szTemp), NULL);
				SelectObject(hdcOffscreen, hOldFont);
			}
		}
	}
	else if (m_pAlbumList->GetSize())
	{
		DrawBitmapFont(hdcOffscreen, rcTemp, ALSTRING("[No Album Selected]"), TRUE, TRUE);
	}
	else
	{
		DrawBitmapFont(hdcOffscreen, rcTemp, ALSTRING("[No Album]"), TRUE, TRUE);
	}

	if (al_alphablend != 255)
	{
		// select background
		HDC hdcOffscreen2 = CreateCompatibleDC(hdcDraw);
		HBITMAP oldBitmap2 = (HBITMAP)SelectObject(hdcOffscreen2, m_pWinampAL->m_hBmpBackground);

		BLENDFUNCTION bf;			// AlphaBlend function parameter
		bf.BlendOp = AC_SRC_OVER;
		bf.BlendFlags = 0;
		bf.SourceConstantAlpha = 255 - al_alphablend;
		bf.AlphaFormat = 0;

		GdiAlphaBlend(hdcOffscreen, 0,0, rcWnd.right, rcWnd.bottom, hdcOffscreen2, 0, 0, rcWnd.right, rcWnd.bottom, bf); 

		// clean up (select background)
		SelectObject(hdcOffscreen2, oldBitmap2);
		DeleteDC(hdcOffscreen2);
	}

	// copy to it back to the original dc
	BitBlt(hdcDraw, 0, 0, rcWnd.right, rcWnd.bottom, hdcOffscreen, 0, 0, SRCCOPY);

	// clean up
	SelectObject(hdcOffscreen, oldBitmap);
	SelectObject(memDC, hOldBmp);
	DeleteObject(tempBitmap);
	DeleteDC(memDC);
	DeleteDC(hdcOffscreen);

	// release the DC that we created
	if (hDC == NULL)
	{
		ReleaseDC(m_hWnd, hdcDraw);
	}
}

BOOL CWinampWinshade::LButtonDown(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	// resizing rectangle
	if (m_wafResize.PtInFunction(point, &rcWnd))
	{
		m_wafResize.Clicked(point);
		SetCapture(m_hWnd);

		return TRUE;
	}

	return CWinampUI::LButtonDown(nFlags, point);
}

BOOL CWinampWinshade::LButtonUp(UINT nFlags, POINT point)
{
	RECT rcWnd;
	GetClientRect(m_hWnd, &rcWnd);

	if (m_wafResize.IsClicked())
	{
		m_wafResize.Release();
		ReleaseCapture();

		return TRUE;
	}

	return CWinampUI::LButtonUp(nFlags, point);
}

BOOL CWinampWinshade::LButtonDblClk(UINT nFlags, POINT point)
{
	return CWinampUI::LButtonDblClk(nFlags, point);
}

BOOL CWinampWinshade::MouseMove(UINT nFlags, POINT point)
{
	ChooseCursor(point);

	int width, height;
	RECT rcWnd, rcWndClient;
	GetWindowRect(m_hWnd, &rcWnd);
	GetClientRect(m_hWnd, &rcWndClient);

	//Fixed Resizing Code
	if (m_wafResize.IsClicked() && ((nFlags & MK_LBUTTON) == MK_LBUTTON))
	{
		BOOL bSizeChanged = FALSE;

		width = rcWndClient.right;
		height = rcWndClient.bottom;

		//Resize in X direction outwards
		if (point.x >= (m_wafResize.m_ptDown.x + 1))
		{
			int inc = (point.x - (m_wafResize.m_ptDown.x + 1)) / RESIZE_WIDTH + 1;

			rcWndClient.right += inc * RESIZE_WIDTH;
			if(rcWndClient.right >= MIN_WIDTH)
			{
				width = rcWndClient.right;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.x += inc * RESIZE_WIDTH;
			}
		}
		//Resize in X direction inwards
		else if (point.x <= (m_wafResize.m_ptDown.x - RESIZE_WIDTH))
		{
			int inc = (point.x - (m_wafResize.m_ptDown.x - RESIZE_WIDTH)) / RESIZE_WIDTH - 1;

			rcWndClient.right += inc * RESIZE_WIDTH;
			if(rcWndClient.right >= MIN_WIDTH)
			{
				width = rcWndClient.right;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.x += inc * RESIZE_WIDTH;
			}
			else
			{
				width = MIN_WIDTH;
				bSizeChanged = TRUE;
				m_wafResize.m_ptDown.x += MIN_WIDTH - (rcWnd.right - rcWnd.left);
			}
		}
		if (bSizeChanged)
		{
			SetWindowPos(m_hWnd, NULL, 0, 0, width, height, SWP_NOZORDER|SWP_NOMOVE);
		}

		return TRUE;
	}

	return CWinampUI::MouseMove(nFlags, point);
}

void CWinampWinshade::MouseWheel(WORD fwKeys, short zDelta, POINT point)
{
	m_zWheelDelta += zDelta;

	if (abs(m_zWheelDelta) >= WHEEL_DELTA)
	{
		if (m_zWheelDelta < 0)
		{
			PlayNextAlbum();
		}
		else if (m_zWheelDelta > 0)
		{
			PlayPrevAlbum();
		}
		m_zWheelDelta = m_zWheelDelta % WHEEL_DELTA;
	}
}

//////////////////////////////////////////////////////////////////
// CPictureArray class

CPictureArray::CPictureArray() : CPtrArray()
{
}

CPictureArray::~CPictureArray()
{
}

int CPictureArray::Add(LPPICTUREINFO pPicInfo)
{
	return CPtrArray::Add(pPicInfo);
}

LPPICTUREINFO CPictureArray::operator[](int nIndex)
{
	return (LPPICTUREINFO)GetAt(nIndex);
}

void CPictureArray::Sort()
{
	if (GetSize())
	{
		qsort(GetData(), GetSize(), sizeof(LPVOID), Compare);
	}
}

int CPictureArray::Compare(const void *elem1, const void *elem2)
{
	LPPICTUREINFO pPicInfo1 = *(LPPICTUREINFO*)elem1;
	LPPICTUREINFO pPicInfo2 = *(LPPICTUREINFO*)elem2;

	if (pPicInfo1->nType < pPicInfo2->nType) return -1;
	if (pPicInfo1->nType > pPicInfo2->nType) return 1;

	return 0;
}

